#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 17 "lexgrog.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 141
#define YY_END_OF_BUFFER 142
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1559] =
    {   0,
        0,    0,    0,    0,   67,   67,   67,   67,    0,    0,
        0,    0,    0,    0,    0,    0,  119,  119,    0,    0,
        0,    0,    0,    0,  126,  126,    8,    8,    0,    0,
        0,    0,    0,    0,    0,    0,  142,  141,   29,   29,
       29,  140,   67,   67,  140,  140,  140,  138,  140,  136,
       83,   67,   67,  140,   83,  106,  106,  106,  101,  106,
      108,  108,  107,  113,  113,  113,  112,  118,  118,  118,
      118,  118,  119,  121,  121,  120,  123,  123,  122,  125,
      125,  124,  126,  126,  140,  137,  140,  140,  140,    7,
       10,    7,    7,    6,    6,    6,    4,   18,   18,   18,

       19,   19,    0,   28,    0,   27,   27,   29,   67,    0,
      138,    0,    0,  139,   67,   67,  139,  135,  139,  139,
      135,   83,   67,    0,    0,  138,    0,  136,   70,   67,
       76,    0,   62,    0,    0,   64,   66,    0,    0,   61,
       63,   61,    0,    0,    0,    0,    0,    0,   67,    0,
       67,   67,  139,  135,   83,   67,    0,   64,    0,  106,
        0,    0,  101,   94,   95,   96,   97,   98,   99,  100,
      108,  107,  113,    0,    0,    0,  112,  112,  118,    0,
        0,    0,  119,  121,  120,  123,  122,  125,  124,  126,
      137,    0,    0,  126,  126,  139,  139,  139,  139,  126,

      137,   54,    0,  126,   39,    7,    0,    9,    0,   10,
        7,    6,    0,    3,    4,    3,    4,    3,   18,    0,
        0,    0,   18,   19,   28,    0,    0,    0,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   57,    0,
        0,   67,    0,    0,   36,   36,   36,   36,   36,   36,
       36,   36,    0,   50,    0,    0,    0,    0,    0,    0,
      130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   48,    0,   57,    0,   49,    0,   58,   76,
       72,    0,    0,    0,    0,    0,    0,    0,    0,   75,
       75,   75,    0,    0,    0,    0,    0,    0,   69,    0,

       77,   78,    0,   79,    0,    0,   81,    0,    0,   67,
        0,    0,   36,   36,   36,   36,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       93,  102,  103,  104,  105,  101,   94,   95,   96,   97,
       98,   99,  100,    0,    0,    0,    0,    0,    0,   60,
        0,  126,   38,   38,  126,   38,   38,   38,   38,   37,
       54,    7,    0,    0,    0,    9,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    5,    3,    3,    4,    4,
        4,    3,    0,    0,    0,    0,    0,   16,    0,   21,

       27,   27,   27,   27,   20,   27,   27,   27,   57,    0,
        0,    0,    0,    0,    0,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   51,   41,    0,    0,    0,    0,
        0,  128,   59,    0,  130,   47,  129,    0,    0,   30,
        0,    0,    0,  127,   34,   53,    0,   35,   33,   52,
       32,    0,    0,    0,   49,   84,   73,   62,   55,   63,

       68,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   85,    0,   87,   92,   88,   89,   90,   91,
        0,    0,    0,   64,    0,   93,  102,  103,  104,  105,
        0,    0,    0,  116,  114,    0,   38,   38,   38,   38,
       37,   38,   38,    7,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    7,    5,    3,    3,    4,    4,    4,    0,    3,
        3,   12,   14,   13,   15,   11,   17,   21,   25,   26,

       20,   22,   24,   23,   55,    0,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   30,   36,   36,   36,   36,
       34,   36,   36,   35,   33,   36,   32,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   40,  132,  131,   45,  128,
       59,   46,   47,  129,  134,  133,   30,   42,   44,   31,
      127,   34,   34,   53,   43,   35,   33,   52,   32,    0,
       84,   55,   74,    0,   71,   56,   80,   82,   36,   36,

       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   85,   86,   87,   92,   88,   89,   90,   91,
        0,   65,    0,  110,    0,  116,  117,  114,  115,   38,
       38,    7,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    3,    3,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    3,    3,
       25,   26,   22,   24,   23,   56,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   30,   36,   36,   31,   36,
       34,   34,   36,   36,   35,   33,   36,   32,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
      132,  131,   45,  134,  133,   44,   43,   56,   56,   82,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       86,   65,  109,  110,  111,  117,  115,    7,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    3,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,

       36,   36,   36,   36,   36,   36,   36,   36,  109,  111,
        7,    0,    2,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    7,    3,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    1,    4,    1,    4,    4,    4,    4,

        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    0,    1,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    3,   36,   36,   36,    7,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    7,    3,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,

        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    4,    1,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        1,    1,    4,    4,    4,    4,    4,    4,    1,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    0,    1,
        1,    0,    0,    0,    0,    0,    0,    1,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    3,    7,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    3,
        4,    4,    1,    0,    1,    0,    0,    1,    0,    0,
        0,    0,    0,    0,    1,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
        3,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    8,    0,    0,    1,    0,    1,    0,
        0,    0,    0,    0,    1,    1,    0,    0,    0,    0,

        0,    0,    1,    1,    1,    0,    1,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    0,    0,    0,    0,    0,    1,    0,    1,
        0,    0,    0,    0,    0,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    0,    0,    0,
        0,    0,    1,    1,    0,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    0,    0,    0,    0,    1,    1,
        1,    1,    1,    1,    0,    0,    0,    0,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        0,    0,    0,    0,    1,    1,    1,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0
    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,    6,   10,   11,   12,
       13,   14,   15,   16,   17,   18,    1,   19,   20,   21,
       22,   23,   24,   25,   26,   27,   27,    1,    1,    1,
        1,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       54,   55,   56,    6,   57,   58,   59,   60,   61,   62,

       63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
       83,   84,    6,   85,    6,   86,    1,    1,   87,    1,
        1,   88,   89,   90,    1,    1,   91,   92,    1,    1,
       93,    1,    1,   94,   95,   96,    1,    1,   97,    1,
       98,   99,    1,    1,    1,  100,  101,  102,    1,    1,
      103,    1,    1,  104,  105,  106,  107,  108,  109,  110,
        1,    1,  111,  112,  113,  114,  115,    1,  116,  117,
        1,    1,    1,    1,  118,    1,  119,    1,  120,  121,
        1,    1,    1,    1,  122,  123,    1,    1,    1,    1,

        1,    1,    1,  124,    1,    1,    1,  125,    1,    1,
        1,    1,    1,    1,    1,  126,  127,    1,    1,    1,
        1,    1,    1,  128,    1,    1,    1,  129,  130,    1,
      131,    1,    1,    1,  132,  133,    1,    1,  134,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[135] =
    {   0,
        1,    2,    3,    4,    2,    1,    5,    1,    1,    1,
        6,    7,    1,    1,    1,    1,    1,    1,    8,    9,
        9,    9,    9,    8,    8,    8,    8,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,    1,    1,    1,    1,    1,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1
    } ;

static const flex_int16_t yy_base[1743] =
    {   0,
        0,    0,    0,    2,    6,    0,  139,  143,  146,  147,
      227,    0,  361,    0,  145,  492, 5667, 5666,  570,    0,
      704,    0,  838,    0,  150,  159,  154,  167,  169,  170,
        0,    0,  174,  179, 5655, 5654, 5657, 7380, 7380,  199,
     5644, 7380,  495,  502,  971, 5437, 5436,  184, 5473,    0,
     1024,  982,  989, 5486,  491, 7380, 5485, 5466,  195,  501,
     7380, 5483,    0, 7380, 5482,  149,  217, 7380, 5481, 5416,
     5419, 5422,    0, 7380, 5477,    0, 7380, 5476,    0, 7380,
     5475,    0,  994, 1000, 5474,  513,  209, 5471, 5418,    0,
      530, 5471, 5468, 7380, 5469, 5416, 1012,    0,  525, 5467,

     7380, 5466,  544,  548, 5465,    0, 1078, 1048, 1113, 1129,
      536, 5450, 1057, 7380, 1134, 1145, 1156, 5411, 5401, 5438,
     1210, 1285, 1174, 5447, 5368,  551,  553,    0, 7380,  984,
        0, 1181, 7380, 1151,  490,  558, 7380, 1004,  498, 5374,
     7380, 7380, 5439,    0, 5438, 5442, 1290, 1012, 1164,  978,
     1192, 1230, 5445, 1238,  968, 1317, 1314, 7380, 1002, 7380,
     5367, 1203, 1376,  976,  977, 1016, 1043, 1070, 1075, 1090,
     7380,    0, 7380, 5376, 5381, 5379, 1139, 1162, 7380, 5363,
     5304, 5309,    0, 7380,    0, 7380,    0, 7380,    0, 1321,
     1328, 1384, 5369, 1351, 1400, 5370, 1008, 5367, 5314, 1405,

     1409, 1413, 5367, 1185, 7380,    0, 1417, 1461, 5366, 1421,
     5363, 7380, 5360, 5359, 5357, 5355, 1393, 5354,    0, 1234,
     5356, 1395, 1240, 7380, 7380, 5346, 1430, 5345,    0, 1442,
     1448, 5276,  170, 1439, 5274, 1111, 5267, 1434, 1170, 1197,
     1210, 1479, 1510, 1516, 5341, 1521, 1527,  992, 1058,  162,
     1593, 1668, 1389, 7380, 5340, 1501, 5299, 1554, 5298,  439,
     1430, 1507, 1526, 5268, 1158,    0, 5263, 5274,  487, 1057,
     5271, 1569, 7380, 5322, 1273, 1235,    0, 5293, 1487,    0,
     7380,    0, 5246,  153, 5245, 5220, 5231, 5218, 5226, 7380,
        0,    0, 1540,    0,    0,  941, 5212, 5227, 7380,    0,

     7380, 7380,    0, 7380,    0, 1669, 7380, 1547,    0, 1565,
     1021, 5290, 1545, 5289, 1753, 1828, 5211, 1572, 5213, 5205,
      999, 5204, 5203, 1491, 1081, 5201, 5216, 1110, 5199, 5214,
     1505, 1558, 1605, 1611, 1621, 1622, 1628, 1645, 1654, 1656,
     1661, 1662, 1679, 5206, 5201, 5198, 5214, 5203, 5202, 1695,
     1699, 1704,    0, 1708, 1715, 5271, 1728, 5268, 5215, 7380,
     1762,    0, 1913, 5268,    0, 1771, 5267,  477, 5229,  496,
      945, 1892, 5240, 5145, 5220, 5151, 5143,   92, 5156, 5163,
     5139, 1104, 5139, 5147, 5242,    0, 5239, 5238, 5237, 5236,
     1819, 5234, 5195, 5218, 5164, 5189, 5162, 7380, 5161,    0,

     1703, 1709, 1710, 1731, 1785, 1801, 1805, 1807, 1814, 1212,
     5119, 5134, 1270, 5117, 5132, 5195, 1848, 1856, 1109, 1867,
     1918, 1247, 1151, 1852, 1861, 5194, 1941, 1331, 1964, 1428,
     1381, 1959, 1949, 1965, 1137, 1815, 2046, 1380, 1125, 1896,
     1924, 1167, 1981, 5193, 1874,    0, 1998, 5190, 5189, 1991,
     5179, 1936, 5187, 2058, 2041, 1142, 5186, 5185, 2101, 2127,
     2200, 1451, 2282, 2098, 7380, 1968, 1839, 1891, 1931, 1943,
     1974, 2001, 2008, 2024, 2030, 2063, 2100, 2106, 2112, 2113,
     2114, 2123, 2179, 2180, 2290,    0, 2211, 2212, 2213,    0,
     2217, 1365, 5104, 5119,    0, 2218, 7380, 7380, 2219, 7380,

     7380,    0,    0, 5174, 5128, 5127,    0,    0, 5175, 5170,
     5177, 2293, 1297, 2284, 1261, 1017, 1680, 1180, 1427, 2252,
     5176, 2253, 2252, 5096, 2253, 2286, 2288, 2320, 2325, 2330,
     1423, 5094, 5109, 7380, 5119, 2331, 2332, 2336, 2337, 2338,
     5108, 5114, 5109, 2342, 2343, 5108,    0, 2347, 2351, 5165,
        0, 2357,    0,    0, 2411, 5166,    0, 1522, 5136, 2314,
     1540, 2346, 1565, 1591, 1597, 1743, 2347, 2285, 5118, 5065,
     1726, 1410, 5030, 5028, 1191, 5026, 5041, 5057, 5029, 5059,
     5030, 5140,    0, 5136, 5135, 5107, 5106, 2543, 2675, 5105,
     5104, 7380, 7380, 7380, 7380, 7380, 7380,    0,    0,    0,

     2365,    0,    0,    0, 2376, 5050, 2319, 2326,    0, 5092,
     2378, 2396, 2402, 2406, 2417, 2418, 2419, 2423, 2427, 2432,
     2433, 2437, 2439, 2441, 2448, 2454, 2455, 2459, 2460, 2461,
     2465,    0, 2466, 2467, 2471,    0, 2472,    0,    0,    0,
     5045, 1508, 5044, 5019, 5034, 5021, 5027,    0,    0, 2477,
     1349, 1530, 5013, 5028,    0, 2781,    0,    0, 2807,    0,
     1732, 2470,    0, 2496, 1713, 7380,    0,    0,    0, 2478,
     2479, 2497, 2498, 2503,    0,    0, 2504, 2508,    0, 2509,
     2510, 2514, 2515,    0,    0, 2516, 2520,    0, 2521, 5038,
     2522, 2526, 7380, 5037, 7380, 2528, 7380,    0, 2547, 5010,

     2549, 2551, 2553, 2555, 2557, 2559, 1547, 5008, 5023, 1697,
     5006, 5021, 2561, 2563, 2565, 2569, 2571, 2573, 2580, 2586,
     5031, 7380, 5027, 2587, 5015, 2591, 2592, 2597, 2598, 2602,
     2609,    0, 1765, 2613, 1802, 5072, 1560, 1853, 1957, 2591,
     1958, 2545, 2310, 2625, 2419, 2632, 2545, 2556, 5055, 5041,
     5041, 4966, 4988, 4971, 4977, 4982, 4987, 4955, 4966, 4944,
     2619, 4942, 4928, 4925, 5051,    0,    0,    0,    0, 2890,
     2867, 2588, 5014, 2582, 2593, 2658, 5025, 4930, 1318, 5003,
     4933, 4923,  119, 4936, 4951, 4928, 1683, 4929, 4935, 2903,
     2599, 4995, 2601, 2620, 2661, 5004, 4909, 1804, 4982, 4913,

     4905, 1728, 4918, 4934, 4911, 1837, 4912, 4919,    0,    0,
        0,    0,    0,    0,    0, 2637, 1886, 4936, 4951, 1911,
     4933, 4948,    0, 2641,    0,    0,    0,    0, 2642, 2643,
     2653, 2655, 2679,    0,    0, 2683, 2694,    0, 2696, 2705,
     2721, 2727,    0,    0, 2731, 2733,    0, 2739,    0,    0,
     2741,    0,    0,    0, 1845, 4958, 3009, 3035, 2005, 2048,
        0,    0,    0,    0,    0,    0,    0, 2743, 2749,    0,
     2750, 2751, 2755, 2756, 2757, 2761, 2762, 2763,    0, 4957,
     2767, 7380, 2768, 2769, 2773, 2774, 2779,    0, 2672, 2783,
     2787, 5008, 2856, 4999, 4960, 2877, 2866, 2897, 2884, 4976,

     4913, 4891, 4879, 4878, 4875, 4882, 4872, 4885, 1861, 1694,
     1945, 4878, 4878, 4889, 4989,    0,    0, 3118, 3095, 2885,
     4953, 2878, 2888, 3109, 4964, 4869, 2236, 4944, 4874, 4865,
     1972, 4875, 4887, 4863, 2032, 4853, 4860, 2868, 4925, 2969,
     2882, 2925, 2875, 2885, 2888, 2895, 3146, 2873, 4904, 4859,
     3240, 3187, 2227, 2095, 4797, 4796, 2187, 4794, 4809, 4825,
     4797, 4827, 4798, 2888, 4882, 3112, 2926, 3266, 2922, 2933,
     2935, 2937, 3267, 2916, 4862, 4818, 4897, 3337, 2326, 2279,
     4782, 4779, 2224, 4775, 4789, 4805, 4775, 4779, 4750,    0,
     2788, 4810, 2789,    0,    0,    0,    0,    0,    0,    0,

     2859,    0,    0, 2860,    0, 2910, 2904,    0, 2978, 2983,
        0, 2949, 2984, 3124, 2949, 3101, 3090, 4822, 3175, 1375,
     2615, 4751, 4728, 4764, 4760, 4738, 2688, 4749, 4731, 4729,
     4737, 4729, 4743, 4825,    0,    0, 3363, 3340, 3108, 4789,
     3112, 3121, 3269, 4799, 4704, 2465, 4779, 4688, 4679, 2705,
     4692, 4706, 4683, 2867, 4683, 4661, 3103, 4721, 3134, 3119,
     3356, 3114, 3129, 3153, 3158, 3373, 3146, 4699, 4654, 3485,
     3524, 2624, 2959, 4614, 4610, 3069, 4608, 4615, 4631, 4603,
     4632, 4603, 3169, 3316, 3175, 4707, 1771, 3193, 3196, 3268,
     3257, 3263, 3252, 3383, 3267, 3550, 3272, 3255, 4671, 4653,

     3596, 3529, 3455, 3554, 4651, 4576, 4598, 4580, 4556, 4561,
     4566, 4534, 4541, 4519, 3370, 4517, 4511, 4510, 3278, 3414,
     3271, 4626, 2478, 3272, 3282, 3361, 3283, 3358, 3336, 3443,
     3361, 3661, 3366, 3358, 4605, 4588,    0, 3659, 3716, 3721,
     4562, 4487, 4509, 4492, 4494, 4499, 4504, 4471, 4481, 4455,
     3429, 4452, 4446, 4446,    0, 3141, 3252, 3444,    0, 3377,
     4534, 3456, 3507, 4423, 4422, 4419, 4424, 4411, 4424, 3559,
     3583, 3612, 4400, 3667, 4524, 4520, 4517, 3853, 3830, 3535,
     3141, 3533, 3549, 3762, 2631, 1186, 3407, 2319, 2113, 2366,
     3476, 2856, 3366, 2980, 3613, 3342, 2626, 3644, 3183, 3657,

     3651, 3858, 3611, 3658, 3678, 3704, 3881, 3668, 2426, 3497,
     2770, 3792, 3643, 3372, 1618, 2594, 3444, 1940, 3375, 3487,
     1878, 3004, 2680, 3669, 3746, 3706, 3246, 3715, 3723, 3760,
     3873, 3756, 3724, 3745, 3867, 3766, 3942, 3820, 3815, 3231,
     2065, 4514, 3963, 4000, 4002, 3567, 3323, 3371, 3027, 3604,
     3615, 3367, 3434, 3447, 3599, 3921, 3586, 3561, 2533, 3796,
     3874, 3908, 3827, 3833, 3592, 3676, 3836, 3763, 3941, 3829,
     3233, 4041, 3765, 3428, 3612, 3666, 3816, 3843, 3593, 1047,
     2377, 1460, 3905, 3917, 3880, 3831, 3813, 3895, 3897, 3988,
     3914, 3669, 3893, 4509, 4460, 3939, 3971, 4027, 4008, 4476,

     4493, 4422, 4431, 4399, 4368, 4355, 4353, 4350, 4356, 4346,
     4357, 3842, 3848, 3904, 4346, 4318, 4329, 4426, 7380, 4000,
     4394, 3895, 4325, 4308, 4296, 4310, 4071, 4075, 4098, 4102,
     4106, 4110, 4114, 4118, 4134, 4138, 4324, 4410,    0,    0,
     7380, 4115, 4012, 4020, 4053, 4398, 4152, 4143, 4022, 4034,
     4018, 4373, 4166, 4395, 4152, 3765, 3961, 4289, 4261, 4295,
     4291, 4262, 3976, 4273, 4251, 4242, 4245, 4235, 4248,    0,
        0, 4085, 4285, 4199, 4197, 4193, 4190, 4226, 4197, 4192,
     4197, 4201, 4212, 4296, 4114,    0, 4158, 4195, 4221, 4258,
     4210, 4215,    0, 4228, 4265, 4272, 4168, 4163, 4160, 4150,

     4135, 4146, 4276, 4282, 4289, 4123, 4295, 4112, 4222, 4152,
     4131, 4128, 4135, 4208, 4286, 4135, 4146, 4173, 4291, 4112,
     4068, 4050, 4034, 4035, 4314, 4321, 4327, 4328, 4357, 4361,
     4365, 4372, 4373, 4383, 4384, 4390, 4391, 4052, 4220, 4085,
     4397, 4401, 3999, 4211, 4437, 4082, 4052, 3945, 3940, 3931,
     3919, 3955, 3924, 4412, 4521, 4464, 4442, 4575, 4491, 4446,
     4629, 4681, 3940, 3888, 3874, 4220, 4690, 4406,    0, 4424,
     3941, 3857, 3841, 3830, 3836, 4735, 4470, 4787, 4529, 4841,
     4530, 4796, 4584, 4895, 4630, 4947, 4638, 3793, 3778, 4239,
     4420, 3784, 4736, 4690, 3668, 4482, 4901, 4953, 4706, 4957,

     4974, 4710, 4978, 4982, 3682, 3654, 3653, 3644, 5043, 5087,
     5139, 5183, 5235, 5279, 3592, 3549, 3542, 3483, 5331, 4742,
     5359, 4749, 5358, 4750, 5386, 4850, 5438, 4857, 5466, 4858,
     3505, 3403, 3326, 3321, 4738, 4812, 4816, 3140, 3114, 3067,
     3055, 3033, 2925, 2843, 2577, 2548, 2351, 2058, 1985, 1935,
     1824, 1794, 1654, 1660, 1542, 1465, 1467, 7380, 5519, 5530,
     5541, 5552, 5563, 5574, 5585, 5596, 5607, 5618, 5629, 5633,
     5644, 5655, 5666, 5677, 5688, 5699, 5710, 5721, 5732, 5743,
     5754, 5765, 5769, 5780, 5791, 5802, 5813, 5818, 5819, 5824,
     5835, 5846, 5857, 5868, 5879, 5890, 5901, 5912, 5923, 5934,

     5945, 5956, 5967, 1525, 5978, 5989, 6000, 6011, 6022, 6033,
     6044, 6055,  175, 6057, 6068, 6079, 6090, 6101, 6112, 6123,
     6134, 6145, 6156, 6167, 6178, 6189, 6200, 6211, 6222, 6233,
     6244, 6255, 6266, 6277,  520, 6279, 6290, 6301, 6312, 6323,
     6334, 6345, 6356, 6367, 6378, 6389, 6400, 6411, 6422, 6433,
     6444, 6455, 6466, 6477, 6488, 6499, 6510, 6521, 6532, 6543,
     6554, 6565, 6576, 6587, 6598, 6609, 6620, 6631, 6642, 6653,
     6664, 6675, 6686, 6697, 6708, 6719, 6730, 6741, 6752, 6763,
     6774, 6785, 6796, 6807, 6818, 6829, 6840, 6851, 6862, 6873,
     6884, 6895, 6906, 6917, 6928, 6939, 6950, 6961, 6972, 6983,

     6994, 7005, 7016, 7027, 7038, 7049, 7060, 7071, 7082, 7093,
     7104, 7109, 7119, 7130, 7141, 7152, 7163, 7174, 7185, 7196,
     7207, 7218, 7229, 7240,  532, 7251, 7262, 7273, 7284, 7295,
     7306, 7313, 7323, 7328, 7332,  980, 1317, 7342, 7353, 7364,
     7369, 1340
    } ;

static const flex_int16_t yy_def[1743] =
    {   0,
     1559, 1559, 1560, 1560, 1558,    5,    5,    5, 1561, 1561,
     1558,   11, 1558,   13, 1562, 1562, 1563, 1563, 1558,   19,
     1558,   21, 1558,   23, 1564, 1564, 1565, 1565, 1566, 1566,
     1559, 1559, 1567, 1567, 1568, 1568, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1569, 1558, 1558, 1558, 1558, 1558, 1570,
     1558, 1558, 1569, 1558,   51, 1558, 1558, 1558, 1571, 1558,
     1558, 1558, 1572, 1558, 1558, 1558, 1573, 1558, 1558, 1558,
     1558, 1558, 1574, 1558, 1558, 1575, 1558, 1558, 1576, 1558,
     1558, 1577, 1558, 1569, 1558, 1558, 1558, 1558, 1558, 1578,
     1558, 1578, 1578, 1558, 1558, 1558, 1579, 1580, 1558, 1580,

     1558, 1558, 1558, 1558, 1558, 1581, 1581, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1582, 1558, 1558, 1558, 1558,
     1558, 1558, 1569, 1558, 1558, 1558, 1558, 1583, 1558, 1558,
     1584, 1558, 1558, 1585, 1586, 1558, 1558, 1558, 1587, 1558,
     1558, 1558, 1588, 1589, 1590, 1558, 1558, 1558, 1558, 1558,
     1558, 1582, 1558,  121,  122, 1569, 1585, 1558, 1587, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1591, 1558, 1558, 1558, 1558, 1592, 1558, 1558, 1558,
     1558, 1558, 1593, 1558, 1594, 1558, 1595, 1558, 1596, 1558,
     1558, 1558, 1558, 1558, 1597, 1558, 1558, 1558, 1558, 1569,

     1558, 1558, 1558, 1558, 1558, 1598, 1558, 1558, 1558, 1558,
     1598, 1558, 1558, 1599, 1600, 1599, 1600, 1599, 1601, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1602, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1558, 1558,
     1558, 1558, 1603, 1558, 1603, 1603, 1603, 1603, 1603, 1603,
     1603, 1603, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1604, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1605, 1558, 1558, 1606, 1558, 1558, 1607,
     1558, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1608, 1558,
     1609, 1610, 1558, 1611, 1612, 1612, 1612, 1612, 1558, 1613,

     1558, 1558, 1614, 1558, 1615, 1558, 1558, 1558, 1616, 1558,
     1603, 1558, 1603, 1603, 1603, 1603, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1608, 1608, 1608, 1612, 1612, 1612,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1617, 1617, 1618, 1617, 1617, 1617, 1617, 1558,
     1558, 1619, 1558, 1558,  363,  363, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1619, 1620, 1621, 1621, 1622, 1622,
     1622, 1623, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1624,

     1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1603, 1603, 1603, 1603, 1603,
     1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603,
     1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603,
     1603, 1603, 1603, 1603, 1603, 1626, 1603, 1603, 1603, 1627,
     1628, 1603, 1603, 1603, 1603, 1603, 1603, 1603,  437,  437,
      437, 1603, 1603, 1603, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1629, 1558, 1558, 1558, 1630,
     1558, 1558, 1558, 1558, 1631, 1558, 1558, 1558, 1558, 1558,

     1558, 1632, 1633, 1634, 1558, 1558, 1635, 1636, 1637, 1638,
     1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1639,
     1603, 1603, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1641, 1558, 1558,  555, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1641, 1642, 1643, 1643, 1644, 1644, 1644, 1558, 1645,
     1645, 1558, 1558, 1558, 1558, 1558, 1558, 1646, 1647, 1648,

     1649, 1650, 1651, 1652, 1558, 1558, 1653, 1653, 1654, 1653,
     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,
     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,
     1653, 1655, 1653, 1653, 1653, 1656, 1653, 1657, 1653, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1653, 1659, 1653,
     1660, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,
     1661, 1653, 1653, 1653, 1662, 1558, 1663, 1664, 1665, 1558,
     1558, 1558, 1558, 1558, 1666, 1667, 1558, 1558, 1668, 1558,
     1558, 1558, 1558, 1669, 1670, 1558, 1558, 1671, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1672, 1653, 1653,

     1653, 1653, 1653, 1653, 1653, 1653, 1673, 1673, 1673, 1653,
     1653, 1653, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1674,
     1674, 1675, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1675, 1676, 1677, 1678, 1679, 1678,
     1679, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1678, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1680, 1681,
     1682, 1683, 1684, 1685, 1686, 1558, 1653, 1653, 1653, 1653,
     1653, 1653, 1687, 1653, 1653, 1688, 1689, 1690, 1653, 1653,
     1653, 1653, 1653, 1691, 1692, 1653, 1653, 1693, 1653, 1653,
     1653, 1653, 1694, 1695, 1653, 1653, 1696, 1653, 1653, 1653,
     1653, 1653, 1653, 1697, 1698, 1653, 1653, 1653, 1699, 1700,
     1701, 1702, 1703, 1704, 1705, 1706, 1707, 1558, 1558, 1708,
     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653, 1653,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1709, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1709, 1710, 1711, 1711, 1711, 1711,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711, 1711,
     1711, 1711, 1711, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1712, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1713,
     1653, 1653, 1653, 1714, 1715, 1716, 1717, 1718, 1719, 1720,

     1653, 1653, 1653, 1653, 1653, 1721, 1653, 1653, 1558, 1558,
     1722, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1722, 1723, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1725, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1726, 1653, 1653, 1721, 1727, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1728,
     1729, 1730, 1558, 1558, 1727, 1731, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1732, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1725, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1732, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1272, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1733, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1729, 1728, 1728, 1728,
     1729, 1729, 1729, 1730, 1730, 1730, 1558, 1558, 1731, 1731,
     1558, 1558, 1558, 1558, 1558, 1734, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1735, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1733,
     1733, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1728,
     1729, 1730, 1558, 1558, 1558, 1736, 1558, 1558, 1558, 1558,
     1558, 1558, 1737, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1738, 1739, 1740, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1734, 1558, 1558, 1558, 1735, 1558,
     1558, 1558, 1558, 1558, 1739, 1738, 1738, 1738, 1738, 1739,
     1739, 1739, 1739, 1740, 1740, 1740, 1740, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1741, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1738, 1738, 1738, 1739, 1739, 1739, 1740,
     1740, 1740, 1558, 1558, 1558, 1558, 1558, 1558, 1742, 1558,
     1558, 1558, 1558, 1558, 1558, 1738, 1738, 1738, 1738, 1739,
     1739, 1739, 1739, 1740, 1740, 1740, 1740, 1558, 1558, 1558,
     1741, 1558, 1558, 1558, 1558, 1455, 1738, 1738, 1458, 1739,

     1739, 1461, 1740, 1740, 1558, 1558, 1558, 1558, 1738, 1455,
     1739, 1458, 1740, 1461, 1558, 1558, 1558, 1558, 1738, 1738,
     1476, 1738, 1739, 1739, 1480, 1739, 1740, 1740, 1484, 1740,
     1558, 1558, 1558, 1558, 1510, 1512, 1514, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558,    0, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558
    } ;

static const flex_int16_t yy_nxt[7515] =
    {   0,
     1558, 1558,   40,   41,   40,   41,   42,   43,   44,   45,
       43,   42,   42,   42,   42,   42,   46,   47,   42,   42,
       42,   48,   49,   46,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   42,
       51,   42,   42,   42,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       52,   53,   54,   52,   52,   53,   54,   52,   69,   57,
       57,   83,   84,   85,   83,   42,   91,   92,   93,   42,
       83,   84,   85,   83, 1558,   86,   87,   58,   58,   91,
       92,   93,   95,   95,   86,   87,   99,  100,  424,   96,
       96,   99,  100,   70,  507,  126,   97,   97,  126,   71,
      573,   72,  574,   55,   59,   59,  163,   55,  401,  163,

      103,  104,  105,  103,   88,  401,   89,  174,  175,  106,
      176,  202,  203,   88,   70,   89,  107,  955,  178,  956,
       71,  178,   72,  499,  499,   60,   60,   61,   61,   61,
       62,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       61,   61,   61,   61,   61,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   64,   64,   64,   65,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   66,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   64,   64,   64,   64,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   69,  109,  110,  110,  109,

      473,  291,  157,  115,  116,  117,  115,  158,  558,  474,
      111,  112,  118,  119,  201,  201,  201,  201,  120,  121,
      164,  165,  166,  167,  168,  169,  170,  220,  221,  301,
       70,  207,  208,  209,  207,  560,   71,  126,   72,  558,
      126, 1301,  222,  292,  159,  103,  225,  226,  103,  113,
      227,  228,  126,  486,  279,  126,  122,  279,  106,  279,
      296,   70,  279,  297,  487,  107,  560,   71,  298,   72,
       74,   74,   74,   75,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,

       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   74,   74,   74,   74,   74,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,

       74,   74,   74,   74,   77,   77,   77,   78,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   77,   77,   77,
       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   80,   80,
       80,   81,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   80,   80,   80,   80,   80,   82,   82,   82,   82,

       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,  110,  123,  110,  110,  561,  337,  338,  157,
      337,  338,  130,  149,  158,  130,  149,  112,  130, 1415,
      151,  152,  153,  151, 1558,  190,  130,  111,  190,  118,

      119,  194,  195,  196,  194,  293,  154,  561,  293,  191,
      192,  506,  506,  308,  294,  215,  308,  339,  216, 1558,
      339,  324,  309,  311,  511,  112,  129,  129,  130,  129,
      131,  131,  132,  129,  133,  134,  150,  135,  150,  360,
      136,  137,  130,  155,  340,  197,  422,  340,  193,  103,
      104,  105,  103, 1341,  198,  130,  199,  217,  106,  360,
     1558,  130,  138,  130,  328,  107,  218,  329,  240,  474,
      360,  341,  330,  239,  341,  130,  342,  139,  140,  342,
      528,  141,  129,  138,  129,  129,  142,  143,  217,  138,
      360,  343,  144,  138,  343,  145,  146,  129,  703,  129,

      147,  130,  129,  138,  148,  138,  230,  129,  129,  130,
      241, 1558,  423,  231,  109,  110,  110,  109,  232,  488,
      488,  489,  233,  234,  235,  424,  236, 1558,  111,  112,
      110,  110,  110,  110,  130,  242,  243,  244,  242, 1558,
      178,  237,  130,  178, 1558,  112,  246,  116,  247,  246,
      112,  534,  534, 1558,  238,  248,  249,  110,  116,  110,
      110,  250,  251,  178, 1359,  149,  178,  113,  149, 1558,
      407,  409,  112,  407,  409,  115,  116,  117,  115,  111,
      535,  535, 1558,  112,  118,  119,  204,  631,  113,  204,
      120,  121, 1341,  310,  311,  312,  310,  578,  579,  252,

      281,  281,  281,  281,  281,  281,  281,  281,  627,  283,
      112,  253,  254,  284,  253,  285,  286,  482,  150,  655,
      482,  287,  332,  333,  334,  335,  288,  255,  122,  289,
      636,  313,  152,  314,  313,  610,  220,  221,  256,  193,
      248,  249,  220,  221,  257,  258,  150,  315,  259, 1558,
      260,  222,  261,  609,  262,  263,  264,  222,  265,  410,
      266,  705,  411, 1558,  124,  317,  318,  412,  319,  267,
      320,  268,  413,  269,  409,  414,  270,  409,  321,  322,
      415,  271,  605,  605,  316,  323,  272,  129,  129,  130,
      129,  131,  131,  132,  273,  133,  134,  492,  274, 1558,

      493,  275,  137,  130,  306,  494,  306,  976,  307,  307,
      307,  307,  307,  307,  307,  307,  307,  757,  151,  152,
      153,  151,  190,  138,  758,  190, 1419,  118,  119,  201,
      201,  201,  201, 1558,  154,  702,  191,  192,  276,  140,
      606,  606,  141,  129,  138,  129,  129,  142,  143, 1491,
      138,  504,  352,  144,  138,  352,  145,  146,  129,  416,
      129,  147,  130,  129,  138,  148,  138,  192,  129,  129,
      130,  155,  283,  614,  699,  193,  325,  336,  285,  326,
      336,  951, 1558, 1558,  327,  350,  350,  350,  350,  288,
      253,  254,  289,  253,  952,  332,  333,  334,  335,  390,

      351,  354,  355,  356,  354,  193,  194,  195,  196,  194,
      201,  201,  201,  201,  361,  361,  361,  361,  207,  363,
      364,  207,  207,  208,  209,  207,  393,  391,  394, 1558,
     1558,  475,  227,  228,  475,  690,  690,  395,  391,  396,
      106,  397,  619,  400,  391,  357,  400,  107,  398,  400,
      197,  620,  400, 1558,  358,  630,  359,  661,  391,  198,
      476,  199,  365,  366,  367,  365, 1341,  401,  405,  391,
      618, 1162,  477,  405,  399,  391,  402,  401,  401,  405,
      242,  243,  244,  242,  405,  405,  401, 1163,  279,  368,
      405,  279,  402,  721,  721,  112,  369,  370,  403,  405,

      371,  372,  466,  373,  405,  466,  536,  374,  706,  536,
      405,  417,  243,  418,  417,  405,  405,  110,  243,  110,
      110,  405,  420,  110,  417,  420,  419,  375,  417,  116,
      417,  417,  112,  113,  483,  467,  467,  419,  478,  753,
      754,  293,  467,  419,  293,  467,  445, 1558,  308,  445,
      294,  308,  479,  531,  467,  466,  532,  309,  466,  537,
      480,  533,  537, 1396,  419,  467,  310,  311,  312,  310,
      112,  480, 1361,  466,  733,  421,  466,  480,  851,  851,
      738,  419,  469,  376,  377,  378,  379,  380,  381, 1557,
      382,  480,  383,  384,  425,  254,  470,  425,  469,  512,

      856,  856,  480,  480,  471,  733,  538,  467,  480,  538,
      426,  738,  539,  744,  480,  539,  467,  879,  879,  150,
      480,  427,  540,  336, 1341,  540,  336,  428,  429,  337,
      745,  430,  337,  431,  480,  432,  746,  433,  434,  435,
     1556,  436,  491,  437,  744,  480,  338,  422,  524,  338,
      735,  480,  438,  525,  439,  339,  440,  340,  339,  441,
      340,  745,  341,  342,  442,  341,  342,  746,  735,  443,
      129,  444,  445,  444,  446,  446,  447,  448,  449,  450,
      343,  451, 1558,  343,  452,  453,  445,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  350,  350,  350,  350,

      350,  350,  350,  350,  400,  352,  454,  400,  352,  548,
      400,  599,  548,  400,  599,  510,  354,  355,  356,  354,
      192,  455,  456,  416,  549,  457,  444,  454,  444,  444,
      458,  459,  600,  454,  509,  600,  460,  454,  416,  461,
      462,  444, 1145,  444,  463,  445,  444,  454,  464,  454,
      620,  444,  444,  445,  425,  254, 1163,  425,  193,  551,
      357,  704,  550,  361,  361,  361,  361,  880,  880,  358,
      426,  359,  557,  366,  367,  557,  960,  961, 1555,  551,
      513,  514,  747,  515,  901,  516,  601,  428,  429,  601,
      551,  430,  751,  517,  518,  432,  889,  433,  434,  435,

      519,  436,  602,  437, 1028,  602,  603,  422,  604,  603,
      551,  604,  438,  747,  439,  409,  440, 1558,  409,  441,
      588,  589,  588,  588,  442,  587,  981,  889,  982,  443,
      129,  444,  445,  444,  446,  446,  447,  448,  449,  520,
      466,  451,  893,  466,  521,  453,  445,  504,  752,  417,
      110,  417,  417,  611, 1558, 1003,  611,  417,  243,  417,
      417, 1226,  425,  254,  419,  425,  454,  977,  420,  110,
      417,  420,  419,  893,  628,  445, 1558,  628,  445, 1226,
      978,  522,  456,  419, 1341,  457,  444,  454,  444,  444,
      458,  459,  667,  454,  744,  667,  460,  454, 1558,  461,

      462,  444,  419,  444,  463,  445,  444,  454,  464,  454,
      419,  444,  444,  445,  365,  555,  556,  365, 1554,  562,
     1558,  421,  445,  563, 1553,  744, 1558,  564,  512,  607,
      986,  987,  466,  565,  424,  466,  445,  611, 1558,  566,
      611,  368,  612, 1558,  668,  612, 1341,  668,  369,  370,
      567, 1558,  371,  372,  563,  373,  991,  991,  564,  374,
      621, 1558,  632,  621,  565,  612, 1558, 1558,  612,  466,
      566,  608,  466,  633,  666,  669,  613,  613,  669,  375,
      624,  992,  992, 1558,  613,  613,  634,  634,  635,  622,
     1026, 1027,  615,  613,  625,  445,  744, 1152,  744,  626,

     1558,  623,  670,  445,  613,  670,  616,  509,  615,  671,
      626, 1005,  671,  568,  617,  626,  626,  639,  639,  639,
      639,  639,  639,  639,  639,  672,  626,  744,  672,  744,
      626,  475,  626, 1552,  475,  376,  377,  378,  379,  380,
      381,  626,  382, 1558,  383,  384,  626,  626, 1558,  641,
      510, 1029, 1030,  642,  637,  643,  644,  626, 1006,  650,
     1558,  645,  650,  626,  673, 1149,  646,  673,  651,  647,
     1074, 1341, 1075,  629,  629,  629,  629,  629,  629,  629,
      629,  629,  629,  629,  629,  629,  629,  629,  629,  629,
      629,  629,  629,  629,  629,  629,  629,  629,  629,  664,

     1558,  674,  664,  652,  674, 1130,  653,  675,  665, 1551,
      675,  654,  656,  676,  677,  678,  676,  677,  678, 1341,
      657,  657,  657,  657,  679, 1079, 1080,  679,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      680,  681, 1550,  680,  681,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,

      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  659,  685,  686,  687,  685,  686,  687,  689,  691,
      692,  689,  691,  692, 1107, 1108,  799,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  713,  715, 1558,  713,  715,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660, 1558,  612, 1558,  716,  612,  717,
      716,  682,  717, 1105,  682, 1558,  662,  445,  662, 1070,

      663,  663,  663,  663,  663,  663,  663,  663,  663,  683,
      641,  445, 1071, 1111,  707,  710,  643,  708,  711,  613,
     1112,  718,  709,  712,  718, 1341,  719,  646,  613,  719,
      647,  720,  536,  537,  720,  536,  537,  538,  539,  540,
      538,  539,  540,  726,  728,  735,  726,  728,  548, 1106,
     1147,  548,  730,  350,  730,  730,  683, 1148,  552,  896,
      700,  552,  727,  549,  979,  701,  601,  731,  736,  601,
      445,  748, 1341,  739,  739,  563,  735,  692,  445,  611,
      692,  817,  611, 1341,  818,  740,  740,  748,  820,  819,
      896,  821, 1141,  563,  741,  741,  822,  612,  742,  743,

      612,  550,  825,  612,  739,  739,  612,  826, 1143, 1144,
      826,  550,  557,  555,  556,  557,  740,  740,  612,  827,
      828,  612,  827,  828,  829,  741,  741,  829,  830,  743,
      743,  830, 1341,  831,  621,  737,  831,  621,  832,  368,
      833,  832,  834,  833, 1549,  834,  369,  370, 1142,  835,
      371,  372,  835,  373,  744,  836,  837,  374,  836,  837,
      838,  839,  840,  838,  839,  840,  841,  844,  845,  841,
      844,  845,  846,  848, 1135,  846,  848,  375,  650,  670,
      671,  650,  670,  671,  842,  744,  980,  651,  663,  663,
      663,  663,  663,  663,  663,  663,  663,  664,  672,  673,

      664,  672,  673, 1360,  674,  677,  665,  674,  677,  678,
      680,  681,  678,  680,  681,  682,  682,  686,  682,  682,
      686,  687,  689,  691,  687,  689,  691,  692, 1211,  869,
      692,  842,  869,  376,  377,  378,  379,  380,  381, 1341,
      382, 1212,  383,  384,  770,  589,  770,  770,  871,  771,
      873,  871,  874,  873,  875,  874,  876,  875,  877,  876,
      878,  877,  713,  878,  881,  713,  715,  881, 1121,  715,
      716,  772,  717,  716,  718,  717,  744,  718,  773,  774,
      895,  719,  775,  776,  719,  777, 1121,  720,  884,  778,
      720,  884,  726,  886,  896,  726,  886,  779,  728,  887,

     1341,  728,  887,  730,  350,  730,  730,  744,  899,  780,
      730,  350,  730,  730,  890,  891,  892,  890,  744,  938,
      909,  940,  744,  909,  941,  896,  890,  891,  892,  890,
      964,  744, 1341,  890,  891,  892,  890, 1341,  869,  899,
      966,  869,  993,  829,  830,  993,  829,  830, 1548,  744,
      938,  967,  940,  744,  831,  941,  832,  831,  975,  832,
      897,  964,  744,  898, 1317,  781,  782,  783,  784,  785,
      786,  966,  787,  744,  788,  789,  589,  589,  589,  589,
      833,  790,  967,  833,  836,  942, 1341,  836,  968,  943,
     1246,  897,  969,  944,  898,  837,  970,  839,  837,  945,

      839, 1547,  971,  791,  744,  946,  840, 1012,  972,  840,
      792,  793, 1164, 1165,  794,  795,  947,  796, 1146,  973,
      943,  797,  841,  969,  944,  841,  989,  970,  841,  798,
      945,  841,  845,  971,  846,  845,  946,  846, 1012,  972,
      848,  799, 1001,  848,  869, 1001, 1247,  869,  910,  911,
      869,  871, 1007,  869,  871, 1007,  873,  874,  875,  873,
      874,  875,  876,  877,  878,  876,  877,  878,  881, 1009,
      884,  881, 1009,  884, 1010,  886, 1341, 1010,  886,  948,
      887, 1137,  974,  887,  890,  891,  892,  890, 1013, 1001,
      993, 1013, 1001,  993, 1169, 1030, 1154,  800,  801,  802,

      803,  804,  805, 1215,  806, 1216,  807,  808,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
     1001, 1157, 1341, 1001, 1157,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  918,  589,  918,  918,  772,  919, 1014,  890,  891,

      892,  890,  773,  774,  744, 1007,  775,  776, 1007,  777,
     1016,  416,  870,  778,  416, 1017, 1057, 1059,  920, 1060,
     1083,  779, 1088, 1094, 1095,  921,  922, 1096, 1014,  923,
      924,  791,  925,  780, 1097,  744,  926,  744,  792,  793,
     1119, 1016,  794,  795,  927,  796, 1017, 1057, 1059,  797,
     1060, 1083, 1089, 1088, 1094, 1095,  928,  798, 1096, 1098,
     1220, 1221,  983, 1062, 1090, 1097, 1124, 1546,  744,  799,
     1130, 1119, 1131, 1091, 1132, 1098, 1133, 1092, 1160, 1009,
      735, 1062, 1009, 1089, 1010, 1013, 1341, 1010, 1013,  781,
      782,  783,  784,  785,  786, 1090,  787, 1124,  788,  789,

     1085, 1130, 1134, 1131, 1091, 1132,  969, 1133, 1093, 1160,
     1341,  735,  929,  930,  931,  932,  933,  934, 1134,  935,
     1545,  936,  937, 1086,  969,  800,  801,  802,  803,  804,
      805, 1085,  806, 1341,  807,  808,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660, 1248, 1249,
     1087,  985, 1153,  660,  660,  660,  660,  660,  660,  660,

      660,  660,  660,  660,  660,  660,  660,  660,  660,  660,
      660,  660,  660,  660,  660,  660,  660,  660,  660, 1037,
      589, 1037, 1037, 1039, 1038,  890,  891,  892,  890, 1396,
     1040, 1041,  744, 1305, 1042, 1043, 1061, 1044, 1014, 1198,
     1062, 1045, 1157, 1121, 1063, 1157, 1039, 1341, 1544, 1046,
     1064, 1200, 1201, 1040, 1041, 1224, 1065, 1042, 1043, 1229,
     1044, 1047, 1235,  744, 1045, 1226, 1122, 1066, 1236, 1014,
     1198, 1062, 1046, 1089, 1121, 1063,  890,  891,  892,  890,
      965, 1064, 1200, 1201, 1047, 1090, 1224, 1065, 1227, 1341,
     1229, 1543, 1237, 1235, 1091, 1252, 1226, 1238, 1093, 1236,

     1260, 1103, 1253, 1103, 1089, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1120, 1264, 1090, 1048, 1049, 1050,
     1051, 1052, 1053, 1237, 1054, 1091, 1055, 1056, 1238, 1093,
     1067, 1260, 1239, 1123, 1235, 1235, 1203, 1341, 1542, 1341,
     1048, 1049, 1050, 1051, 1052, 1053, 1264, 1054, 1239, 1055,
     1056, 1101, 1341, 1157, 1203, 1228, 1157, 1294, 1300, 1102,
     1102, 1102, 1102, 1352, 1541, 1235, 1235, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102, 1102,
     1102, 1102, 1102, 1125, 1125, 1235, 1202, 1235, 1266, 1235,

     1203, 1267, 1235, 1235, 1204, 1126, 1126, 1270, 1235, 1289,
     1205, 1293, 1267, 1130, 1127, 1127, 1206, 1261, 1128, 1129,
     1261, 1130, 1262, 1130, 1125, 1125, 1235, 1207, 1235, 1341,
     1235, 1203, 1267, 1235, 1235, 1204, 1126, 1126, 1270, 1235,
     1289, 1205, 1293, 1267, 1130, 1127, 1127, 1206, 1341, 1129,
     1129, 1139, 1130, 1139, 1130, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1140, 1178,  589, 1178, 1178, 1180, 1179,
     1263, 1283, 1341, 1341, 1283, 1181, 1182, 1341, 1341, 1183,
     1184, 1341, 1185, 1230, 1261, 1296, 1186, 1261, 1130, 1262,
     1208, 1180, 1130, 1295, 1187, 1231, 1130, 1130, 1181, 1182,

     1230, 1130, 1183, 1184, 1232, 1185, 1188, 1296, 1233, 1186,
     1299, 1320, 1231, 1341, 1230, 1290, 1296, 1187, 1290, 1130,
     1291, 1232, 1540, 1130, 1539, 1234, 1231, 1130, 1130, 1188,
     1312, 1230, 1130, 1312, 1341, 1232, 1141, 1263, 1296, 1234,
     1341, 1299, 1320, 1231, 1290,  416,  870, 1290,  416, 1291,
     1341,  988, 1232, 1341, 1308,  984, 1234,  890,  891,  892,
      890, 1304, 1189, 1190, 1191, 1192, 1193, 1194, 1292, 1195,
      977, 1196, 1197, 1245, 1245, 1245, 1245, 1245, 1245, 1245,
     1245, 1245, 1341,  978, 1150, 1189, 1190, 1191, 1192, 1193,
     1194, 1354, 1195, 1341, 1196, 1197, 1242, 1292, 1538, 1284,

     1285, 1143, 1144, 1341, 1243, 1243, 1243, 1243,  890,  891,
      892,  890, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
     1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243,
     1243, 1243, 1243, 1243, 1243, 1243, 1243, 1243, 1244, 1341,
     1244, 1341, 1245, 1245, 1245, 1245, 1245, 1245, 1245, 1245,
     1245, 1261, 1309, 1310, 1261, 1341, 1262, 1180, 1313, 1314,
     1329,  891, 1330, 1329, 1181, 1182,  964, 1341, 1183, 1184,
     1147, 1185,  966, 1341,  981, 1186,  982, 1148, 1268, 1151,
      967, 1269, 1180, 1273, 1332,  891, 1333, 1332, 1136, 1181,
     1182, 1235, 1341, 1183, 1184, 1188, 1185,  964, 1341, 1341,

     1186, 1163, 1349,  966, 1263, 1341, 1130, 1534, 1274, 1268,
     1341,  967, 1269, 1335,  891, 1336, 1335, 1341, 1341, 1341,
     1188, 1341, 1235, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
     1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1341,
     1341, 1189, 1190, 1191, 1192, 1193, 1194, 1341, 1195, 1130,
     1196, 1197, 1290, 1341, 1341, 1290, 1533, 1291,  890,  891,
      892,  890, 1341, 1532, 1341, 1341, 1189, 1190, 1191, 1192,
     1193, 1194, 1341, 1195, 1341, 1196, 1197,  791, 1121, 1297,
     1130, 1124, 1298, 1316,  792,  793, 1119, 1131,  794,  795,

     1289,  796, 1130, 1306, 1355,  797,  986,  987, 1307, 1141,
     1341, 1122, 1341, 1302, 1315, 1292, 1531, 1132, 1358, 1121,
     1297, 1341, 1124, 1298, 1120,  799, 1311, 1119, 1131, 1341,
     1341, 1289, 1346, 1130, 1140, 1140, 1140, 1140, 1140, 1140,
     1140, 1140, 1140, 1133, 1518, 1347, 1293, 1290, 1132,  791,
     1290, 1341, 1343, 1517, 1134, 1516,  792,  793,  969, 1295,
      794,  795, 1341,  796, 1130, 1142, 1341,  797, 1341, 1341,
     1134, 1341, 1341, 1296, 1133, 1303,  969, 1293, 1123, 1355,
     1515,  800,  801,  802,  803,  804,  805,  799,  806,  968,
      807,  808, 1508,  969, 1296, 1130, 1130,  970, 1341, 1130,

     1292, 1130, 1341,  971, 1296, 1121, 1139, 1350, 1139,  972,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1140, 1341,
      973, 1341, 1341, 1121,  969, 1296, 1341, 1130,  970, 1130,
     1130, 1344, 1130, 1341,  971, 1341, 1341, 1341, 1350, 1341,
      972, 1353, 1341,  800,  801,  802,  803,  804,  805, 1341,
      806, 1130,  807,  808,  589,  589,  589,  589,  791, 1342,
     1351, 1395, 1344, 1130, 1341,  792,  793, 1299, 1290,  794,
      795, 1290,  796, 1343, 1348, 1290,  797, 1396, 1290, 1341,
     1343,  791, 1130,  974,  798, 1125, 1341, 1341,  792,  793,
     1346, 1351,  794,  795, 1130,  796,  799, 1126, 1299,  797,

     1130, 1341, 1506, 1347, 1130, 1348, 1127,  798, 1125, 1345,
     1128, 1341, 1345, 1130, 1341, 1345, 1125, 1505, 1345,  799,
     1126, 1292, 1312, 1341, 1130, 1312, 1495, 1341, 1126, 1127,
     1368, 1130, 1344, 1129, 1348, 1130, 1494, 1127, 1304, 1125,
     1356, 1129, 1290, 1290, 1130, 1290, 1290, 1343, 1343, 1367,
     1493, 1126,  800,  801,  802,  803,  804,  805, 1364,  806,
     1127,  807,  808, 1344, 1129, 1348, 1130, 1357, 1492, 1341,
     1297, 1362, 1363, 1298, 1489,  800,  801,  802,  803,  804,
      805, 1130,  806, 1130,  807,  808, 1365, 1366, 1488, 1290,
     1374,  791, 1290, 1375, 1291, 1292, 1292, 1130,  792,  793,

     1369, 1297,  794,  795, 1298,  796, 1341, 1304, 1341,  797,
     1365, 1366, 1130, 1345, 1130, 1350, 1345, 1302, 1140, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1364, 1290,  799,
      791, 1290, 1405, 1291, 1362, 1363, 1130,  792,  793, 1351,
     1372,  794,  795, 1130,  796, 1475, 1350, 1341,  797, 1385,
     1313, 1314, 1558, 1121, 1345, 1474, 1303, 1345, 1397, 1398,
     1558, 1558, 1558, 1558, 1473, 1130, 1348, 1130,  799, 1472,
     1351, 1372, 1332,  891, 1333, 1332, 1380,  891, 1330, 1380,
     1385, 1292, 1402, 1366, 1121,  800,  801,  802,  803,  804,
      805, 1471,  806, 1469,  807,  808, 1130, 1348, 1130, 1380,

      891, 1330, 1380, 1380,  891, 1330, 1380, 1381,  891, 1333,
     1381, 1381,  891, 1333, 1381, 1381,  891, 1333, 1381, 1382,
      891, 1336, 1382, 1465,  800,  801,  802,  803,  804,  805,
      744,  806, 1408,  807,  808, 1382,  891, 1336, 1382, 1382,
      891, 1336, 1382,  791, 1290, 1463, 1453, 1290, 1414, 1291,
      792,  793, 1439, 1290,  794,  795, 1290,  796, 1291, 1290,
     1452,  797, 1290, 1408, 1291, 1451, 1388, 1450, 1388,  798,
     1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1389, 1414,
     1391,  799, 1391, 1439, 1392, 1392, 1392, 1392, 1392, 1392,
     1392, 1392, 1392, 1380,  891, 1330, 1380, 1292, 1381,  891,

     1333, 1381, 1382,  891, 1336, 1382, 1292, 1448, 1447, 1446,
     1449, 1445, 1416, 1389, 1389, 1389, 1389, 1389, 1389, 1389,
     1389, 1389, 1290,  744, 1443, 1290, 1442, 1291, 1392, 1392,
     1392, 1392, 1392, 1392, 1392, 1392, 1392,  800,  801,  802,
      803,  804,  805,  791,  806, 1441,  807,  808, 1444, 1440,
      792,  793, 1438,  744,  794,  795,  791,  796, 1466, 1425,
     1490,  797, 1424,  792,  793, 1423, 1290,  794,  795, 1290,
      796, 1291, 1130, 1290,  797, 1417, 1290, 1427, 1291, 1444,
     1427,  799, 1428, 1431,  744, 1422, 1431, 1421, 1432, 1466,
     1435, 1490, 1420, 1435,  799, 1436, 1290, 1558, 1418, 1290,

     1384, 1291, 1558, 1130, 1172, 1558, 1558, 1558, 1558,  744,
     1558, 1558, 1558, 1558,  744, 1431, 1413, 1412, 1431, 1292,
     1432, 1411, 1454, 1410, 1409, 1454, 1292, 1428, 1454, 1454,
     1429, 1454, 1454, 1428, 1428, 1407, 1433,  800,  801,  802,
      803,  804,  805, 1437,  806, 1407,  807,  808, 1406, 1292,
      800,  801,  802,  803,  804,  805, 1405,  806, 1454,  807,
      808, 1454, 1457, 1428, 1404, 1457, 1457, 1432, 1433, 1457,
     1403, 1432, 1364, 1457, 1457, 1429, 1457, 1457, 1432, 1432,
     1401, 1429, 1429, 1130, 1460, 1460, 1400, 1460, 1460, 1436,
     1436, 1460, 1460, 1399, 1460, 1460, 1436, 1436,  890,  891,

      892,  890,  890,  891,  892,  890, 1393, 1290, 1390, 1386,
     1290, 1429, 1291, 1454, 1384, 1433, 1454, 1383, 1428, 1433,
     1455, 1379, 1378, 1377, 1376, 1290, 1433, 1433, 1290, 1373,
     1291, 1558, 1371, 1456, 1369, 1368, 1458, 1437, 1437, 1558,
     1558, 1558, 1558, 1457, 1437, 1437, 1457, 1460, 1432, 1459,
     1460, 1467, 1436, 1467, 1461, 1468, 1468, 1468, 1468, 1468,
     1468, 1468, 1468, 1468, 1367, 1454, 1429, 1462, 1454, 1361,
     1428, 1454, 1360, 1359, 1454, 1358, 1428, 1357, 1478, 1356,
     1478, 1355, 1479, 1479, 1479, 1479, 1479, 1479, 1479, 1479,
     1479, 1355, 1457, 1426, 1354, 1457, 1433, 1432, 1353, 1558,

     1437, 1426, 1426, 1426, 1426, 1482, 1352, 1482, 1120, 1483,
     1483, 1483, 1483, 1483, 1483, 1483, 1483, 1483, 1429, 1349,
     1341, 1464, 1454, 1341, 1497, 1454, 1340, 1428, 1338, 1337,
     1454, 1457, 1476, 1454, 1457, 1428, 1432, 1327, 1326, 1325,
     1477, 1477, 1477, 1477, 1324, 1433, 1323, 1322, 1477, 1477,
     1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477,
     1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477, 1477,
     1477, 1477, 1477, 1477, 1321, 1429, 1457, 1317, 1316, 1457,
     1315, 1432, 1311, 1498, 1500, 1457, 1480, 1310, 1457, 1309,
     1432, 1308, 1307, 1306, 1481, 1481, 1481, 1481, 1305, 1304,

     1141, 1130, 1481, 1481, 1481, 1481, 1481, 1481, 1481, 1481,
     1481, 1481, 1481, 1481, 1481, 1481, 1481, 1481, 1481, 1481,
     1481, 1481, 1481, 1481, 1481, 1481, 1481, 1481, 1130, 1433,
     1460, 1460, 1300, 1460, 1460, 1436, 1436, 1294, 1501, 1460,
     1484, 1288, 1460, 1287, 1436, 1286, 1282, 1281, 1485, 1485,
     1485, 1485, 1280, 1279, 1278, 1277, 1485, 1485, 1485, 1485,
     1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485,
     1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485, 1485,
     1485, 1485, 1460, 1437, 1503, 1460, 1276, 1436, 1275, 1246,
     1235, 1290, 1504, 1235, 1290, 1486, 1291, 1486, 1271, 1487,

     1487, 1487, 1487, 1487, 1487, 1487, 1487, 1487, 1468, 1468,
     1468, 1468, 1468, 1468, 1468, 1468, 1468, 1430, 1265, 1259,
     1258, 1434, 1257, 1256, 1255, 1430, 1430, 1430, 1430, 1434,
     1434, 1434, 1434, 1254, 1251, 1437, 1454, 1290, 1250, 1454,
     1290, 1428, 1291, 1454, 1292, 1241, 1454, 1240, 1428, 1426,
     1454, 1457, 1225, 1454, 1457, 1428, 1432, 1426, 1426, 1426,
     1426, 1223, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1454, 1429,
     1292, 1454, 1222, 1428, 1219, 1218, 1498, 1457, 1217, 1214,

     1457, 1188, 1432, 1497, 1501, 1479, 1479, 1479, 1479, 1479,
     1479, 1479, 1479, 1479, 1483, 1483, 1483, 1483, 1483, 1483,
     1483, 1483, 1483, 1430, 1213, 1210, 1209, 1434, 1199, 1175,
     1174, 1430, 1430, 1430, 1430, 1434, 1434, 1434, 1434, 1174,
     1173, 1429, 1457, 1172, 1171, 1457, 1170, 1432, 1028, 1168,
     1433, 1457,  744, 1167, 1457, 1166, 1432, 1161, 1460, 1460,
     1507, 1460, 1460, 1436, 1436, 1156, 1154, 1153, 1499, 1499,
     1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499,
     1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499,
     1499, 1499, 1499, 1499, 1152, 1433, 1460, 1151, 1150, 1460,

     1149, 1436, 1454, 1146, 1500, 1454, 1145, 1428, 1137, 1136,
     1135, 1504, 1503, 1120, 1118, 1117, 1116, 1115, 1114, 1113,
     1110, 1109, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1502, 1502, 1460, 1437,
     1100, 1460, 1099, 1436, 1454, 1429, 1084, 1454, 1457, 1428,
     1082, 1457, 1081, 1432, 1455, 1487, 1487, 1487, 1487, 1487,
     1487, 1487, 1487, 1487, 1078, 1457, 1077, 1509, 1457, 1460,
     1432, 1076, 1460, 1460, 1436, 1073, 1460, 1047, 1436, 1072,
     1069, 1068, 1058, 1034, 1033, 1032, 1031, 1025, 1024, 1023,

     1022, 1437, 1021, 1020, 1019, 1019, 1018, 1429,  734, 1015,
      891, 1433, 1008, 1004,  992,  992, 1510,  991,  991,  989,
     1458,  988,  985,  984,  983,  980,  799,  979, 1433, 1456,
      976,  975, 1437, 1511,  965,  963, 1437, 1512,  962,  959,
      958, 1461,  957,  954, 1454, 1514,  928, 1454,  953, 1428,
     1459,  950,  949,  939, 1513,  915,  914, 1519, 1462, 1519,
      913, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,
      912,  908,  907,  906,  905,  904,  903,  902,  901,  751,
      744,  744,  900,  894,  885,  883,  882,  880,  880,  879,
      879,  872,  693,  868,  856,  856,  853, 1429, 1521,  853,

      851,  851,  852,  850,  824,  816, 1522, 1522, 1522, 1522,
      810,  810,  769,  769, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522, 1522,
     1457,  767,  767, 1457,  765, 1432,  764,  763,  762,  761,
      760,  759,  756, 1523,  755, 1523,  750, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1524,  749,  734,  555,  552,
      729,  725,  724,  723,  722,  721,  721,  714, 1558,  311,
      698,  697,  696,  497,  695,  690,  690, 1558, 1558, 1558,
      649, 1558, 1558, 1433, 1525, 1558,  465, 1558,  606,  606,

      605,  605, 1526, 1526, 1526, 1526,  597,  596,  595,  594,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1526, 1526, 1460,  593,  592, 1460,
      591, 1436,  587,  587,  585,  585,  582,  581,  580, 1527,
      577, 1527,  576, 1528, 1528, 1528, 1528, 1528, 1528, 1528,
     1528, 1528,  575,  572,  375,  571,  570,  569,  559,  366,
      363,  553,  552,  355,  546,  545,  544,  543,  542,  541,
      535,  535,  534,  534,  530,  529,  527,  526,  523, 1437,
     1529,  152,  311,  506,  506,  501,  501,  499, 1530, 1530,

     1530, 1530,  499,  500,  498,  496, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1530,
     1530, 1530, 1454,  291,  490, 1454,  485, 1428,  484,  481,
      472,  468,  465, 1558,  408,  406,  404,  227,  225, 1520,
     1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,  220, 1457,
      392,  388, 1457,  390, 1432,  388,  386,  385,  208,  202,
      205,  204,  195,  204,  349,  348, 1524, 1524, 1524, 1524,
     1524, 1524, 1524, 1524, 1524, 1429, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,

     1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535, 1535,
     1535, 1535, 1433, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1536, 1460,
      347,  346, 1460,  345, 1436,  344,  331,  152,  305,  303,
      300,  299,  278,  277,  239,  125, 1528, 1528, 1528, 1528,
     1528, 1528, 1528, 1528, 1528,  124,  239,  104,  224,  223,
      213,  212,  211,  210,  205,  204,  200,  188,  186,  184,
      182,  181,  180,  179,  173,  171,  161,  160,  156,  127,
      125,  124, 1437, 1537, 1537, 1537, 1537, 1537, 1537, 1537,

     1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537,
     1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   38,   38,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   56,   56,   56,   56,   56,   56,   56,   56,   56,
       56,   56,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   68,   68,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   73,   73,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   90,   90,   94,   94,   94,   94,

       94,   94,   94,   94,   94,   94,   94,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  101,  101,  114,
      114,  114,  114,  114,  114,  114,  114,  114,  114,  114,
      128,  128,  128,  128,  162,  162,  108,  162,  162,  162,
      162,  162,  162,  162,  162,  172, 1558,  102,  102,  172,
      172,  172,  172,  172,  172,  172,  177,  177,   38,   38,
      177,  177,  177,  177,  177,  177,  177,  183,  183, 1558,
      183,  183,  183,  183,  183,  183,  183,  183,  185, 1558,
     1558, 1558,  185,  185,  185,  185,  185,  185,  185,  187,

     1558, 1558, 1558,  187,  187,  187,  187,  187,  187,  187,
      189, 1558, 1558, 1558,  189,  189,  189,  189,  189,  189,
      189,  206,  206, 1558,  206,  206,  206,  206,  206,  206,
      206,  206,  214,  214, 1558,  214,  214,  214,  214,  214,
      214,  214,  214,  219,  219, 1558,  219,  219,  219,  219,
      219,  219,  219,  219,  229,  229, 1558,  229,  229,  229,
      229,  229,  229,  229,  229,  245,  245,  245,  245,  245,
      245,  245,  245,  245,  245,  245,  128,  128,  128,  128,
      280,  280, 1558,  280,  280,  280,  280,  280,  280,  280,
      280,  282,  282, 1558,  282,  282,  282,  282,  282,  282,

      282,  282,  290,  290, 1558,  290,  290,  290,  290,  290,
      290,  290,  290,  295,  295, 1558,  295,  295,  295,  295,
      295,  295,  295,  295,  301, 1558,  301,  301,  302,  302,
      304, 1558, 1558,  304,  304,  172, 1558, 1558, 1558,  172,
      172,  172,  172,  172,  172,  172,  177,  177, 1558, 1558,
      177,  177,  177,  177,  177,  177,  177,  183,  183, 1558,
      183,  183,  183,  183,  183,  183,  183,  183,  185, 1558,
     1558, 1558,  185,  185,  185,  185,  185,  185,  185,  187,
     1558, 1558, 1558,  187,  187,  187,  187,  187,  187,  187,
      189, 1558, 1558, 1558,  189,  189,  189,  189,  189,  189,

      189,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      353,  353,  362,  362, 1558,  362,  362,  362,  362,  362,
      362,  362,  362,  387,  387, 1558,  387,  387,  387,  387,
      387,  387,  387,  387,  389,  389, 1558,  389,  389,  389,
      389,  389,  389,  389,  389,  219,  219, 1558,  219,  219,
      219,  219,  219,  219,  219,  219,  229,  229, 1558,  229,
      229,  229,  229,  229,  229,  229,  229,  416,  416,  416,
      416,  416,  416,  416,  416,  416,  416,  416,  290,  290,
     1558,  290,  290,  290,  290,  290,  290,  290,  290,  495,
      495, 1558,  495,  495,  495,  495,  495,  495,  495,  495,

      280,  280, 1558,  280,  280,  280,  280,  280,  280,  280,
      280,  497,  497, 1558,  497,  497,  497,  497,  497,  497,
      497,  497,  502,  502, 1558,  502,  502,  502,  502,  502,
      502,  502,  502,  503,  503, 1558,  503,  503,  503,  503,
      503,  503,  503,  503,  504,  504,  504,  504,  504, 1558,
      504,  504,  504,  504,  504,  505,  505, 1558,  505,  505,
      505,  505,  505,  505,  505,  505,  508,  508,  509,  509,
      509,  509, 1558,  509,  509,  509,  509,  509,  509,  510,
      510,  510,  510,  510, 1558,  510,  510,  510,  510,  510,
      547,  547, 1558,  547,  547,  547,  547,  547,  547,  547,

      547,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      353,  353,  554,  554, 1558,  554,  554,  554,  554,  554,
      554,  554,  554,  583,  583, 1558,  583,  583,  583,  583,
      583,  583,  583,  583,  584,  584, 1558,  584,  584,  584,
      584,  584,  584,  584,  584,  586,  586, 1558,  586,  586,
      586,  586,  586,  586,  586,  586,  590,  590, 1558,  590,
      590,  590,  590,  590,  590,  590,  590,  598,  598, 1558,
      598,  598,  598,  598,  598,  598,  598,  598,  229,  229,
     1558,  229,  229,  229,  229,  229,  229,  229,  229,  638,
      638, 1558,  638,  638,  638,  638,  638,  638,  638,  638,

      640,  640, 1558,  640,  640,  640,  640,  640,  640,  640,
      640,  648,  648, 1558,  648,  648,  648,  648,  648,  648,
      648,  648,  684,  684, 1558,  684,  684,  684,  684,  684,
      684,  684,  684,  688,  688, 1558,  688,  688,  688,  688,
      688,  688,  688,  688,  495,  495, 1558,  495,  495,  495,
      495,  495,  495,  495,  495,  693,  693, 1558,  693,  693,
      693,  693,  693,  693,  693,  693,  694,  694, 1558,  694,
      694,  694,  694,  694,  694,  694,  694,  504,  504,  504,
      504,  504,  504,  504,  504,  504,  504,  504,  304,  304,
      509,  509,  509,  509,  509,  509,  509,  509,  509,  509,

      509,  510,  510,  510,  510,  510,  510,  510,  510,  510,
      510,  510,  640,  640, 1558,  640,  640,  640,  640,  640,
      640,  640,  640,  547,  547, 1558,  547,  547,  547,  547,
      547,  547,  547,  547,  732,  732, 1558,  732,  732,  732,
      732,  732,  732,  732,  732,  583,  583, 1558,  583,  583,
      583,  583,  583,  583,  583,  583,  766,  766, 1558,  766,
      766,  766,  766,  766,  766,  766,  766,  768,  768, 1558,
      768,  768,  768,  768,  768,  768,  768,  768,  809,  809,
     1558,  809,  809,  809,  809,  809,  809,  809,  809,  598,
      598, 1558,  598,  598,  598,  598,  598,  598,  598,  598,

      811,  811, 1558,  811,  811,  811,  811,  811,  811,  811,
      811,  812,  812, 1558,  812,  812,  812,  812,  812,  812,
      812,  812,  229,  229, 1558,  229,  229,  229,  229,  229,
      229,  229,  229,  813,  813, 1558,  813,  813,  813,  813,
      813,  813,  813,  813,  814,  814, 1558,  814,  814,  814,
      814,  814,  814,  814,  814,  815,  815, 1558,  815,  815,
      815,  815,  815,  815,  815,  815,  416,  416, 1558,  416,
      416,  416,  416,  416,  416,  416,  416,  823,  823, 1558,
      823,  823,  823,  823,  823,  823,  823,  823,  843,  843,
     1558,  843,  843,  843,  843,  843,  843,  843,  843,  847,

      847, 1558,  847,  847,  847,  847,  847,  847,  847,  847,
      638,  638, 1558,  638,  638,  638,  638,  638,  638,  638,
      638,  849,  849, 1558,  849,  849,  849,  849,  849,  849,
      849,  849,  854,  854, 1558,  854,  854,  854,  854,  854,
      854,  854,  854,  855,  855,  855,  855,  855,  855,  855,
      855,  855,  855,  855,  859,  859,  859,  859,  859,  859,
      859,  859,  859,  859,  859,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  860,  860,  861,  861, 1558,  861,
      861,  861,  861,  861,  861,  861,  861,  862,  862, 1558,
      862,  862,  862,  862,  862,  862,  862,  862,  863,  863,

     1558,  863,  863,  863,  863,  863,  863,  863,  863,  864,
      864, 1558,  864,  864,  864,  864,  864,  864,  864,  864,
      865,  865, 1558,  865,  865,  865,  865,  865,  865,  865,
      865,  866,  866, 1558,  866,  866,  866,  866,  866,  866,
      866,  866,  684,  684, 1558,  684,  684,  684,  684,  684,
      684,  684,  684,  867,  867, 1558,  867,  867,  867,  867,
      867,  867,  867,  867,  688,  688, 1558,  688,  688,  688,
      688,  688,  688,  688,  688,  870, 1558,  870,  870,  870,
      870,  870,  870,  870,  870,  870,  849,  849, 1558,  849,
      849,  849,  849,  849,  849,  849,  849,  547,  547,  547,

      547,  547,  547,  547,  547,  547,  547,  547,  888,  888,
     1558,  888,  888,  888,  888,  888,  888,  888,  888,  916,
      916, 1558,  916,  916,  916,  916,  916,  916,  916,  916,
      766,  766, 1558,  766,  766,  766,  766,  766,  766,  766,
      766,  917,  917, 1558,  917,  917,  917,  917,  917,  917,
      917,  917,  768,  768, 1558,  768,  768,  768,  768,  768,
      768,  768,  768,  990,  990, 1558,  990,  990,  990,  990,
      990,  990,  990,  990,  809,  809, 1558,  809,  809,  809,
      809,  809,  809,  809,  809,  811,  811, 1558,  811,  811,
      811,  811,  811,  811,  811,  811,  812,  812, 1558,  812,

      812,  812,  812,  812,  812,  812,  812,  813,  813, 1558,
      813,  813,  813,  813,  813,  813,  813,  813,  814,  814,
     1558,  814,  814,  814,  814,  814,  814,  814,  814,  815,
      815, 1558,  815,  815,  815,  815,  815,  815,  815,  815,
      823,  823, 1558,  823,  823,  823,  823,  823,  823,  823,
      823,  994,  994, 1558,  994,  994,  994,  994,  994,  994,
      994,  994,  995,  995, 1558,  995,  995,  995,  995,  995,
      995,  995,  995,  996,  996, 1558,  996,  996,  996,  996,
      996,  996,  996,  996,  997,  997, 1558,  997,  997,  997,
      997,  997,  997,  997,  997,  998,  998, 1558,  998,  998,

      998,  998,  998,  998,  998,  998,  999,  999, 1558,  999,
      999,  999,  999,  999,  999,  999,  999,  843,  843, 1558,
      843,  843,  843,  843,  843,  843,  843,  843, 1000, 1000,
     1558, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000,  847,
      847, 1558,  847,  847,  847,  847,  847,  847,  847,  847,
     1002, 1002, 1558, 1002, 1002, 1002, 1002, 1002, 1002, 1002,
     1002,  855,  855,  855,  855,  855,  855,  855,  855,  855,
      855,  855,  859,  859,  859,  859,  859,  859,  859,  859,
      859,  859,  859,  860,  860,  860,  860,  860,  860,  860,
      860,  860,  860,  860,  861,  861, 1558,  861,  861,  861,

      861,  861,  861,  861,  861,  862,  862, 1558,  862,  862,
      862,  862,  862,  862,  862,  862,  863,  863, 1558,  863,
      863,  863,  863,  863,  863,  863,  863,  864,  864, 1558,
      864,  864,  864,  864,  864,  864,  864,  864,  865,  865,
     1558,  865,  865,  865,  865,  865,  865,  865,  865,  866,
      866, 1558,  866,  866,  866,  866,  866,  866,  866,  866,
      867,  867, 1558,  867,  867,  867,  867,  867,  867,  867,
      867,  870, 1558,  870,  870,  870,  870,  870,  870,  870,
      870,  870, 1011, 1011, 1558, 1011, 1011, 1011, 1011, 1011,
     1011, 1011, 1011, 1035, 1035, 1558, 1035, 1035, 1035, 1035,

     1035, 1035, 1035, 1035, 1036, 1036, 1558, 1036, 1036, 1036,
     1036, 1036, 1036, 1036, 1036, 1138, 1558, 1138, 1138, 1155,
     1155, 1558, 1155, 1155, 1155, 1155, 1155, 1155, 1155, 1155,
      994,  994, 1558,  994,  994,  994,  994,  994,  994,  994,
      994,  995,  995, 1558,  995,  995,  995,  995,  995,  995,
      995,  995,  996,  996, 1558,  996,  996,  996,  996,  996,
      996,  996,  996,  997,  997, 1558,  997,  997,  997,  997,
      997,  997,  997,  997,  998,  998, 1558,  998,  998,  998,
      998,  998,  998,  998,  998,  999,  999, 1558,  999,  999,
      999,  999,  999,  999,  999,  999, 1000, 1000, 1558, 1000,

     1000, 1000, 1000, 1000, 1000, 1000, 1000, 1158, 1158, 1158,
     1158, 1158, 1158, 1158, 1158, 1158, 1158, 1158, 1159, 1159,
     1558, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 1159, 1176,
     1176, 1558, 1176, 1176, 1176, 1176, 1176, 1176, 1176, 1176,
     1177, 1177, 1558, 1177, 1177, 1177, 1177, 1177, 1177, 1177,
     1177, 1318, 1318, 1558, 1318, 1318, 1318, 1318, 1318, 1318,
     1318, 1318, 1319, 1319, 1558, 1319, 1319, 1319, 1319, 1319,
     1319, 1319, 1319, 1328, 1328, 1328, 1328, 1328, 1328, 1328,
     1328, 1328, 1328, 1328, 1331, 1331, 1331, 1331, 1331, 1331,
     1331, 1331, 1331, 1331, 1331, 1334, 1334, 1334, 1334, 1334,

     1334, 1334, 1334, 1334, 1334, 1334, 1339, 1339, 1558, 1339,
     1339, 1339, 1339, 1339, 1339, 1339, 1339, 1138, 1558, 1138,
     1558, 1138, 1138, 1370, 1370, 1558, 1370, 1370, 1370, 1370,
     1370, 1370, 1370, 1370, 1387, 1558, 1387, 1387, 1394, 1558,
     1394, 1394, 1426, 1426, 1558, 1426, 1426, 1426, 1426, 1426,
     1426, 1426, 1426, 1430, 1430, 1558, 1430, 1430, 1430, 1430,
     1430, 1430, 1430, 1430, 1434, 1434, 1558, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1470, 1558, 1470, 1470,   37,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558
    } ;

static const flex_int16_t yy_chk[7515] =
    {   0,
        0,    0,    3,    3,    4,    4,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        7,    7,    7,    7,    8,    8,    8,    8,   15,    9,
       10,   25,   25,   25,   25,    7,   27,   27,   27,    8,
       26,   26,   26,   26,  250,   25,   25,    9,   10,   28,
       28,   28,   29,   30,   26,   26,   33,   33,  250,   29,
       30,   34,   34,   15, 1613,   48,   29,   30,   48,   15,
      378,   15,  378,    7,    9,   10,   59,    8,  233,   59,

       40,   40,   40,   40,   25,  233,   25,   66,   66,   40,
       66,   87,   87,   26,   15,   26,   40,  783,   67,  783,
       15,   67,   15,  284,  284,    9,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   16,   43,   43,   43,   43,

      260,  135,   55,   44,   44,   44,   44,   55,  368,  260,
       43,   43,   44,   44,   86,   86,   86,   86,   44,   44,
       60,   60,   60,   60,   60,   60,   60,   99,   99, 1635,
       16,   91,   91,   91,   91,  370,   16,  111,   16,  368,
      111, 1725,   99,  135,   55,  103,  103,  103,  103,   43,
      104,  104,  126,  269,  127,  126,   44,  127,  104,  136,
      139,   16,  136,  139,  269,  104,  370,   16,  139,   16,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   45,   45,   45,   45,  371,  164,  165,  155,
      164,  165,  150,   52,  155,  130,   52,   45,  130, 1736,
       53,   53,   53,   53,  248,   83,  150,   52,   83,   53,

       53,   84,   84,   84,   84,  138,   53,  371,  138,   83,
       83,  296,  296,  148,  138,   97,  148,  166,   97,  516,
      166,  155,  148,  311,  311,   45,   51,   51,   51,   51,
       51,   51,   51,   51,   51,   51,   52,   51,  130,  197,
       51,   51,   51,   53,  167,   84,  248,  167,   83,  108,
      108,  108,  108, 1280,   84,  150,   84,   97,  108,  197,
      249,  113,   51,  150,  159,  108,   97,  159,  113,  321,
      197,  168,  159,  113,  168,  113,  169,   51,   51,  169,
      321,   51,   51,   51,   51,   51,   51,   51,   97,   51,
      197,  170,   51,   51,  170,   51,   51,   51,  516,   51,

       51,   51,   51,   51,   51,   51,  107,   51,   51,   51,
      113,  419,  249,  107,  109,  109,  109,  109,  107,  270,
      270,  270,  107,  107,  107,  419,  107,  439,  109,  109,
      110,  110,  110,  110,  113,  115,  115,  115,  115,  435,
      177,  107,  113,  177,  456,  110,  116,  116,  116,  116,
      115,  325,  325,  423,  107,  116,  116,  117,  117,  117,
      117,  116,  116,  178, 1280,  149,  178,  109,  149,  442,
      236,  239,  117,  236,  239,  123,  123,  123,  123,  149,
      328,  328,  518,  110,  123,  123,  204,  439,  115,  204,
      123,  123, 1186,  151,  151,  151,  151,  382,  382,  116,

      132,  132,  132,  132,  132,  132,  132,  132,  435,  134,
      117,  121,  121,  134,  121,  134,  134,  265,  149,  456,
      265,  134,  162,  162,  162,  162,  134,  121,  123,  134,
      442,  152,  152,  152,  152,  423,  220,  220,  121,  204,
      152,  152,  223,  223,  121,  121,  151,  152,  121,  422,
      121,  220,  121,  422,  121,  121,  121,  223,  121,  240,
      121,  518,  240,  515,  121,  154,  154,  240,  154,  121,
      154,  121,  241,  121,  275,  241,  121,  275,  154,  154,
      241,  121,  410,  410,  152,  154,  121,  122,  122,  122,
      122,  122,  122,  122,  122,  122,  122,  276,  122,  513,

      276,  122,  122,  122,  147,  276,  147, 1186,  147,  147,
      147,  147,  147,  147,  147,  147,  147,  575,  156,  156,
      156,  156,  190,  122,  575,  190, 1737,  156,  156,  191,
      191,  191,  191,  428,  156,  515,  190,  190,  122,  122,
      413,  413,  122,  122,  122,  122,  122,  122,  122, 1742,
      122,  651,  194,  122,  122,  194,  122,  122,  122,  651,
      122,  122,  122,  122,  122,  122,  122,  194,  122,  122,
      122,  156,  157,  428,  513,  190,  157,  163,  157,  157,
      163,  779,  438,  431,  157,  192,  192,  192,  192,  157,
      253,  253,  157,  253,  779,  163,  163,  163,  163,  217,

      192,  195,  195,  195,  195,  194,  200,  200,  200,  200,
      201,  201,  201,  201,  202,  202,  202,  202,  207,  207,
      207,  207,  210,  210,  210,  210,  222,  217,  222,  519,
      430,  261,  227,  227,  261,  492,  492,  222,  217,  222,
      227,  222,  431,  230,  217,  195,  230,  227,  222,  231,
      200,  431,  231,  462,  195,  438,  195,  462,  217,  200,
      261,  200,  208,  208,  208,  208, 1282,  234,  238,  217,
      430, 1020,  261,  234,  222,  217,  231,  230,  234,  238,
      242,  242,  242,  242,  234,  238,  230, 1020,  279,  208,
      234,  279,  231,  531,  531,  242,  208,  208,  231,  238,

      208,  208,  256,  208,  234,  256,  331,  208,  519,  331,
      238,  243,  243,  243,  243,  234,  238,  244,  244,  244,
      244,  234,  246,  246,  246,  246,  243,  208,  247,  247,
      247,  247,  244,  242, 1604,  262,  256,  246,  262,  572,
      572,  293,  262,  247,  293,  256,  313,  313,  308,  313,
      293,  308,  262,  324,  263,  258,  324,  308,  258,  332,
      263,  324,  332, 1557,  243,  263,  310,  310,  310,  310,
      244,  263, 1282,  318,  558,  246,  318,  263,  642,  642,
      561,  247,  258,  208,  208,  208,  208,  208,  208, 1556,
      208,  263,  208,  208,  251,  251,  258,  251,  258,  313,

      652,  652,  263,  272,  258,  558,  333,  318,  263,  333,
      251,  561,  334,  563,  272,  334,  318,  707,  707,  310,
      272,  251,  335,  336, 1215,  335,  336,  251,  251,  337,
      564,  251,  337,  251,  272,  251,  565,  251,  251,  251,
     1555,  251,  272,  251,  563,  272,  338,  251,  318,  338,
      737,  272,  251,  318,  251,  339,  251,  340,  339,  251,
      340,  564,  341,  342,  251,  341,  342,  565,  737,  251,
      252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
      343,  252,  517,  343,  252,  252,  252,  306,  306,  306,
      306,  306,  306,  306,  306,  306,  350,  350,  350,  350,

      351,  351,  351,  351,  401,  352,  252,  401,  352,  354,
      402,  403,  354,  402,  403,  665,  355,  355,  355,  355,
      352,  252,  252,  665,  354,  252,  252,  252,  252,  252,
      252,  252,  404,  252,  661,  404,  252,  252,  661,  252,
      252,  252, 1215,  252,  252,  252,  252,  252,  252,  252,
      517,  252,  252,  252,  315,  315, 1554,  315,  352,  357,
      355,  517,  354,  361,  361,  361,  361,  710,  710,  355,
      315,  355,  366,  366,  366,  366,  787,  787, 1553,  357,
      315,  315,  566,  315,  910,  315,  405,  315,  315,  405,
      357,  315,  571,  315,  315,  315,  733,  315,  315,  315,

      315,  315,  406,  315,  910,  406,  407,  315,  408,  407,
      357,  408,  315,  566,  315,  409,  315,  436,  409,  315,
      391,  391,  391,  391,  315,  391,  802,  733,  802,  315,
      316,  316,  316,  316,  316,  316,  316,  316,  316,  316,
      467,  316,  735,  467,  316,  316,  316,  855,  571,  417,
      417,  417,  417,  424,  424,  855,  424,  418,  418,  418,
      418, 1087,  425,  425,  417,  425,  316,  798,  420,  420,
      420,  420,  418,  735,  436,  445,  445,  436,  445, 1087,
      798,  316,  316,  420, 1221,  316,  316,  316,  316,  316,
      316,  316,  468,  316,  738,  468,  316,  316,  440,  316,

      316,  316,  417,  316,  316,  316,  316,  316,  316,  316,
      418,  316,  316,  316,  363,  363,  363,  363, 1552,  372,
      421,  420,  421,  372, 1551,  738,  441,  372,  445,  421,
      806,  806,  469,  372,  421,  469,  421,  452,  452,  372,
      452,  363,  427,  427,  470,  427, 1218,  470,  363,  363,
      372,  433,  363,  363,  372,  363,  817,  817,  372,  363,
      432,  432,  440,  432,  372,  429,  429,  434,  429,  466,
      372,  421,  466,  440,  466,  471,  427,  433,  471,  363,
      433,  820,  820,  443,  433,  427,  441,  441,  441,  432,
      909,  909,  429,  434,  433,  421,  739, 1221,  741,  434,

      447,  432,  472,  421,  434,  472,  429,  859,  429,  473,
      434,  859,  473,  372,  429,  443,  434,  447,  447,  447,
      447,  447,  447,  447,  447,  474,  443,  739,  474,  741,
      434,  475,  443, 1550,  475,  363,  363,  363,  363,  363,
      363,  434,  363,  455,  363,  363,  443,  434,  437,  450,
      860,  911,  911,  450,  443,  450,  450,  443,  860,  454,
      454,  450,  454,  443,  476, 1218,  450,  476,  454,  450,
      931, 1241,  931,  437,  437,  437,  437,  437,  437,  437,
      437,  437,  437,  437,  437,  437,  437,  437,  437,  437,
      437,  437,  437,  437,  437,  437,  437,  437,  437,  464,

      464,  477,  464,  455,  477, 1241,  455,  478,  464, 1549,
      478,  455,  459,  479,  480,  481,  479,  480,  481, 1189,
      459,  459,  459,  459,  482,  935,  935,  482,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      483,  484, 1548,  483,  484,  460,  460,  460,  460,  460,
      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,

      460,  460,  460,  460,  460,  460,  460,  460,  460,  460,
      460,  461,  487,  488,  489,  487,  488,  489,  491,  496,
      499,  491,  496,  499,  954,  954, 1189,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  523,  525,  522,  523,  525,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  463,  514,  514,  526,  514,  527,
      526,  485,  527,  953,  485,  512,  463,  512,  463,  927,

      463,  463,  463,  463,  463,  463,  463,  463,  463,  485,
      520,  512,  927,  957,  520,  522,  520,  520,  522,  514,
      957,  528,  520,  522,  528, 1188,  529,  520,  514,  529,
      520,  530,  536,  537,  530,  536,  537,  538,  539,  540,
      538,  539,  540,  544,  545,  560,  544,  545,  548,  953,
      983,  548,  549,  549,  549,  549,  485,  983,  552,  743,
      514,  552,  544,  548, 1188,  514,  601,  549,  560,  601,
      512,  568, 1190,  562,  567,  568,  560,  605,  512,  611,
      605,  607,  611, 1281,  607,  562,  567,  568,  608,  607,
      743,  608,  979,  568,  562,  567,  608,  612,  562,  567,

      612,  548,  612,  613,  562,  567,  613,  614,  980,  980,
      614,  552,  555,  555,  555,  555,  562,  567,  615,  616,
      617,  615,  616,  617,  618,  562,  567,  618,  619,  562,
      567,  619, 1209,  620,  621,  560,  620,  621,  622,  555,
      623,  622,  624,  623, 1547,  624,  555,  555,  979,  625,
      555,  555,  625,  555,  745,  626,  627,  555,  626,  627,
      628,  629,  630,  628,  629,  630,  631,  633,  634,  631,
      633,  634,  635,  637, 1209,  635,  637,  555,  650,  670,
      671,  650,  670,  671,  631,  745, 1190,  650,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  664,  672,  673,

      664,  672,  673, 1281,  674,  677,  664,  674,  677,  678,
      680,  681,  678,  680,  681,  682,  683,  686,  682,  683,
      686,  687,  689,  691,  687,  689,  691,  692, 1046,  696,
      692,  631,  696,  555,  555,  555,  555,  555,  555, 1259,
      555, 1046,  555,  555,  588,  588,  588,  588,  699,  588,
      701,  699,  702,  701,  703,  702,  704,  703,  705,  704,
      706,  705,  713,  706,  714,  713,  715,  714, 1123,  715,
      716,  588,  717,  716,  718,  717,  747,  718,  588,  588,
      742,  719,  588,  588,  719,  588, 1123,  720,  724,  588,
      720,  724,  726,  727,  742,  726,  727,  588,  728,  729,

     1216,  728,  729,  730,  730,  730,  730,  747,  748,  588,
      731,  731,  731,  731,  734,  734,  734,  734,  740,  772,
      761,  774,  740,  761,  775,  742,  744,  744,  744,  744,
      791,  740, 1197,  746,  746,  746,  746, 1185,  816,  748,
      793,  816,  824,  829,  830,  824,  829,  830, 1546,  740,
      772,  794,  774,  740,  831,  775,  832,  831, 1185,  832,
      746,  791,  740,  746, 1259,  588,  588,  588,  588,  588,
      588,  793,  588,  746,  588,  588,  589,  589,  589,  589,
      833,  589,  794,  833,  836,  776, 1223,  836,  795,  776,
     1072,  746,  795,  776,  746,  837,  795,  839,  837,  776,

      839, 1545,  795,  589,  746,  776,  840,  889,  795,  840,
      589,  589, 1021, 1021,  589,  589,  776,  589, 1216,  795,
      776,  589,  841,  795,  776,  841, 1197,  795,  842,  589,
      776,  842,  845,  795,  846,  845,  776,  846,  889,  795,
      848,  589,  851,  848,  868,  851, 1072,  868,  761,  761,
      869,  871,  872,  869,  871,  872,  873,  874,  875,  873,
      874,  875,  876,  877,  878,  876,  877,  878,  881,  883,
      884,  881,  883,  884,  885,  886, 1211,  885,  886,  776,
      887, 1211,  795,  887,  890,  890,  890,  890,  891,  991,
      993,  891,  991,  993, 1027, 1027, 1223,  589,  589,  589,

      589,  589,  589, 1050,  589, 1050,  589,  589,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
     1001, 1004, 1192, 1001, 1004,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  659,  659,  659,  659,  659,  659,
      659,  770,  770,  770,  770,  771,  770,  893,  898,  898,

      898,  898,  771,  771,  896, 1007,  771,  771, 1007,  771,
      897, 1006, 1006,  771, 1006,  899,  920,  922,  770,  923,
      938,  771,  941,  943,  944,  770,  770,  945,  893,  770,
      770,  790,  770,  771,  946,  896,  770,  898,  790,  790,
      964,  897,  790,  790,  770,  790,  899,  920,  922,  790,
      923,  938,  942,  941,  943,  944,  770,  790,  945,  948,
     1054, 1054, 1192,  948,  942,  946,  967, 1544,  898,  790,
      969,  964,  970,  942,  971,  948,  972,  942, 1012, 1009,
     1015,  948, 1009,  942, 1010, 1013, 1194, 1010, 1013,  771,
      771,  771,  771,  771,  771,  942,  771,  967,  771,  771,

      940,  969,  974,  970,  942,  971,  974,  972,  942, 1012,
     1222, 1015,  770,  770,  770,  770,  770,  770,  974,  770,
     1543,  770,  770,  940,  974,  790,  790,  790,  790,  790,
      790,  940,  790, 1249,  790,  790,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  857,  857,  857,  857,  857,  857,  857,  857,
      857,  857,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858, 1073, 1073,
      940, 1194, 1222,  858,  858,  858,  858,  858,  858,  858,

      858,  858,  858,  858,  858,  858,  858,  858,  858,  858,
      858,  858,  858,  858,  858,  858,  858,  858,  858,  918,
      918,  918,  918,  919,  918, 1014, 1014, 1014, 1014, 1542,
      919,  919, 1016, 1249,  919,  919,  924,  919, 1017, 1039,
      924,  919, 1156,  966,  924, 1156,  918, 1181, 1541,  919,
      924, 1041, 1042,  918,  918, 1057,  924,  918,  918, 1060,
      918,  919, 1062, 1016,  918, 1059,  966,  924, 1063, 1017,
     1039,  924,  918,  947,  966,  924, 1019, 1019, 1019, 1019,
     1181,  924, 1041, 1042,  918,  947, 1057,  924, 1059, 1199,
     1060, 1540, 1064, 1062,  947, 1076, 1059, 1065,  947, 1063,

     1083,  952, 1076,  952,  947,  952,  952,  952,  952,  952,
      952,  952,  952,  952, 1199, 1085,  947,  919,  919,  919,
      919,  919,  919, 1064,  919,  947,  919,  919, 1065,  947,
      924, 1083, 1067,  966, 1088, 1089, 1067, 1240, 1539, 1271,
      918,  918,  918,  918,  918,  918, 1085,  918, 1067,  918,
      918,  951, 1227, 1157, 1067, 1059, 1157, 1227, 1240,  951,
      951,  951,  951, 1271, 1538, 1088, 1089,  951,  951,  951,
      951,  951,  951,  951,  951,  951,  951,  951,  951,  951,
      951,  951,  951,  951,  951,  951,  951,  951,  951,  951,
      951,  951,  951,  968,  973, 1090, 1043, 1091, 1092, 1090,

     1043, 1093, 1095, 1097, 1043,  968,  973, 1098, 1090, 1119,
     1043, 1121, 1092, 1124,  968,  973, 1043, 1084,  968,  973,
     1084, 1125, 1084, 1127,  968,  973, 1090, 1043, 1091, 1247,
     1090, 1043, 1093, 1095, 1097, 1043,  968,  973, 1098, 1090,
     1119, 1043, 1121, 1092, 1124,  968,  973, 1043, 1196,  968,
      973,  978, 1125,  978, 1127,  978,  978,  978,  978,  978,
      978,  978,  978,  978, 1037, 1037, 1037, 1037, 1038, 1037,
     1084, 1115, 1193, 1252, 1115, 1038, 1038, 1248, 1214, 1038,
     1038, 1219, 1038, 1061, 1094, 1129, 1038, 1094, 1126, 1094,
     1043, 1037, 1126, 1128, 1038, 1061, 1131, 1133, 1037, 1037,

     1066, 1126, 1037, 1037, 1061, 1037, 1038, 1128, 1061, 1037,
     1134, 1160, 1066, 1187, 1061, 1120, 1129, 1037, 1120, 1126,
     1120, 1066, 1534, 1126, 1533, 1066, 1061, 1131, 1133, 1037,
     1151, 1066, 1126, 1151, 1274, 1061, 1247, 1094, 1128, 1061,
     1253, 1134, 1160, 1066, 1130, 1158, 1158, 1130, 1158, 1130,
     1217, 1196, 1066, 1254, 1252, 1193, 1066, 1162, 1162, 1162,
     1162, 1248, 1038, 1038, 1038, 1038, 1038, 1038, 1120, 1038,
     1187, 1038, 1038, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
     1103, 1103, 1191, 1187, 1219, 1037, 1037, 1037, 1037, 1037,
     1037, 1274, 1037, 1220, 1037, 1037, 1070, 1130, 1532, 1115,

     1115, 1214, 1214, 1210, 1070, 1070, 1070, 1070, 1163, 1163,
     1163, 1163, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070,
     1070, 1070, 1070, 1070, 1070, 1070, 1070, 1070, 1071, 1182,
     1071, 1180, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
     1071, 1096, 1253, 1254, 1096, 1183, 1096, 1102, 1151, 1151,
     1170, 1170, 1170, 1170, 1102, 1102, 1180, 1258, 1102, 1102,
     1217, 1102, 1182, 1246, 1191, 1102, 1191, 1217, 1096, 1220,
     1183, 1096, 1104, 1102, 1171, 1171, 1171, 1171, 1210, 1104,
     1104, 1096, 1257, 1104, 1104, 1102, 1104, 1180, 1265, 1279,

     1104, 1531, 1265, 1182, 1096, 1255, 1246, 1518, 1104, 1096,
     1250, 1183, 1096, 1172, 1172, 1172, 1172, 1203, 1275, 1195,
     1104, 1251, 1096, 1101, 1101, 1101, 1101, 1101, 1101, 1101,
     1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101,
     1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 1101, 1213,
     1198, 1102, 1102, 1102, 1102, 1102, 1102, 1201, 1102, 1203,
     1102, 1102, 1132, 1200, 1204, 1132, 1517, 1132, 1174, 1174,
     1174, 1174, 1276, 1516, 1208, 1224, 1104, 1104, 1104, 1104,
     1104, 1104, 1266, 1104, 1205, 1104, 1104, 1138, 1200, 1132,
     1203, 1201, 1132, 1258, 1138, 1138, 1198, 1204, 1138, 1138,

     1224, 1138, 1132, 1250, 1275, 1138, 1195, 1195, 1251, 1213,
     1206, 1200, 1226, 1138, 1257, 1132, 1515, 1205, 1279, 1200,
     1132, 1228, 1201, 1132, 1266, 1138, 1255, 1198, 1204, 1229,
     1233, 1224, 1292, 1132, 1139, 1139, 1139, 1139, 1139, 1139,
     1139, 1139, 1139, 1206, 1508, 1292, 1226, 1225, 1205, 1140,
     1225, 1234, 1225, 1507, 1208, 1506, 1140, 1140, 1208, 1233,
     1140, 1140, 1232, 1140, 1229, 1213, 1230, 1140, 1184, 1268,
     1208, 1273, 1236, 1233, 1206, 1140, 1208, 1226, 1200, 1276,
     1505, 1138, 1138, 1138, 1138, 1138, 1138, 1140, 1138, 1184,
     1138, 1138, 1495, 1184, 1234, 1229, 1232, 1184, 1212, 1230,

     1225, 1236, 1260, 1184, 1233, 1228, 1212, 1268, 1212, 1184,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1287,
     1184, 1239, 1277, 1228, 1184, 1234, 1238, 1232, 1184, 1492,
     1230, 1260, 1236, 1263, 1184, 1270, 1179, 1286, 1268, 1264,
     1184, 1273, 1267, 1140, 1140, 1140, 1140, 1140, 1140, 1278,
     1140, 1238, 1140, 1140, 1178, 1178, 1178, 1178, 1179, 1178,
     1270, 1356, 1260, 1267, 1202, 1179, 1179, 1239, 1235, 1179,
     1179, 1235, 1179, 1235, 1264, 1261, 1179, 1356, 1261, 1231,
     1261, 1178, 1238, 1184, 1179, 1202, 1285, 1207, 1178, 1178,
     1263, 1270, 1178, 1178, 1267, 1178, 1179, 1202, 1239, 1178,

     1231, 1288, 1489, 1263, 1231, 1264, 1202, 1178, 1207, 1262,
     1202, 1283, 1262, 1231, 1262, 1291, 1202, 1488, 1291, 1178,
     1207, 1235, 1256, 1284, 1475, 1256, 1474, 1256, 1202, 1207,
     1287, 1231, 1289, 1207, 1293, 1231, 1473, 1202, 1313, 1207,
     1277, 1202, 1269, 1237, 1231, 1269, 1237, 1269, 1237, 1286,
     1472, 1207, 1179, 1179, 1179, 1179, 1179, 1179, 1313, 1179,
     1207, 1179, 1179, 1289, 1207, 1293, 1296, 1278, 1471, 1243,
     1237, 1312, 1312, 1237, 1465, 1178, 1178, 1178, 1178, 1178,
     1178, 1269, 1178, 1237, 1178, 1178, 1285, 1285, 1464, 1290,
     1322, 1243, 1290, 1322, 1290, 1269, 1237, 1296, 1243, 1243,

     1288, 1237, 1243, 1243, 1237, 1243, 1244, 1284, 1245, 1243,
     1314, 1314, 1269, 1343, 1237, 1297, 1343, 1243, 1244, 1244,
     1244, 1244, 1244, 1244, 1244, 1244, 1244, 1284, 1298, 1243,
     1245, 1298, 1463, 1298, 1283, 1283, 1453, 1245, 1245, 1299,
     1320, 1245, 1245, 1452, 1245, 1451, 1297, 1272, 1245, 1344,
     1256, 1256, 1272, 1349, 1345, 1450, 1245, 1345, 1357, 1357,
     1272, 1272, 1272, 1272, 1449, 1350, 1351, 1298, 1245, 1448,
     1299, 1320, 1327, 1327, 1327, 1327, 1328, 1328, 1328, 1328,
     1344, 1298, 1363, 1363, 1349, 1243, 1243, 1243, 1243, 1243,
     1243, 1447, 1243, 1446, 1243, 1243, 1350, 1351, 1298, 1329,

     1329, 1329, 1329, 1330, 1330, 1330, 1330, 1331, 1331, 1331,
     1331, 1332, 1332, 1332, 1332, 1333, 1333, 1333, 1333, 1334,
     1334, 1334, 1334, 1443, 1245, 1245, 1245, 1245, 1245, 1245,
     1440, 1245, 1372, 1245, 1245, 1335, 1335, 1335, 1335, 1336,
     1336, 1336, 1336, 1342, 1348, 1438, 1424, 1348, 1385, 1348,
     1342, 1342, 1408, 1355, 1342, 1342, 1355, 1342, 1355, 1387,
     1423, 1342, 1387, 1372, 1387, 1422, 1347, 1421, 1347, 1342,
     1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1347, 1385,
     1353, 1342, 1353, 1408, 1353, 1353, 1353, 1353, 1353, 1353,
     1353, 1353, 1353, 1380, 1380, 1380, 1380, 1348, 1381, 1381,

     1381, 1381, 1382, 1382, 1382, 1382, 1355, 1420, 1418, 1417,
     1420, 1416, 1387, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
     1388, 1388, 1389, 1413, 1412, 1389, 1411, 1389, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1391, 1391, 1342, 1342, 1342,
     1342, 1342, 1342, 1392, 1342, 1410, 1342, 1342, 1414, 1409,
     1392, 1392, 1406, 1439, 1392, 1392, 1394, 1392, 1444, 1402,
     1466, 1392, 1401, 1394, 1394, 1400, 1395, 1394, 1394, 1395,
     1394, 1395, 1490, 1396, 1394, 1389, 1396, 1403, 1396, 1414,
     1403, 1392, 1403, 1404, 1439, 1399, 1404, 1398, 1404, 1444,
     1405, 1466, 1397, 1405, 1394, 1405, 1407, 1415, 1390, 1407,

     1384, 1407, 1419, 1490, 1383, 1415, 1415, 1415, 1415, 1379,
     1419, 1419, 1419, 1419, 1378, 1425, 1377, 1376, 1425, 1395,
     1425, 1375, 1426, 1374, 1373, 1426, 1396, 1426, 1427, 1428,
     1403, 1427, 1428, 1427, 1428, 1369, 1404, 1392, 1392, 1392,
     1392, 1392, 1392, 1405, 1392, 1368, 1392, 1392, 1367, 1407,
     1394, 1394, 1394, 1394, 1394, 1394, 1366, 1394, 1429, 1394,
     1394, 1429, 1430, 1429, 1365, 1430, 1431, 1430, 1425, 1431,
     1364, 1431, 1362, 1432, 1433, 1426, 1432, 1433, 1432, 1433,
     1361, 1427, 1428, 1360, 1434, 1435, 1359, 1434, 1435, 1434,
     1435, 1436, 1437, 1358, 1436, 1437, 1436, 1437, 1441, 1441,

     1441, 1441, 1442, 1442, 1442, 1442, 1354, 1468, 1352, 1346,
     1468, 1429, 1468, 1454, 1338, 1430, 1454, 1337, 1454, 1431,
     1429, 1326, 1325, 1324, 1323, 1470, 1432, 1433, 1470, 1321,
     1470, 1491, 1318, 1429, 1317, 1316, 1433, 1434, 1435, 1491,
     1491, 1491, 1491, 1457, 1436, 1437, 1457, 1460, 1457, 1433,
     1460, 1445, 1460, 1445, 1437, 1445, 1445, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1315, 1456, 1454, 1437, 1456, 1311,
     1456, 1477, 1310, 1309, 1477, 1308, 1477, 1307, 1456, 1306,
     1456, 1305, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1304, 1459, 1496, 1303, 1459, 1457, 1459, 1302, 1301,

     1460, 1496, 1496, 1496, 1496, 1459, 1300, 1459, 1295, 1459,
     1459, 1459, 1459, 1459, 1459, 1459, 1459, 1459, 1456, 1294,
     1242, 1441, 1455, 1177, 1477, 1455, 1176, 1455, 1175, 1173,
     1479, 1481, 1455, 1479, 1481, 1479, 1481, 1169, 1168, 1167,
     1455, 1455, 1455, 1455, 1166, 1459, 1165, 1164, 1455, 1455,
     1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455,
     1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455,
     1455, 1455, 1455, 1455, 1161, 1455, 1458, 1154, 1153, 1458,
     1152, 1458, 1150, 1479, 1481, 1483, 1458, 1149, 1483, 1148,
     1483, 1147, 1146, 1145, 1458, 1458, 1458, 1458, 1144, 1143,

     1142, 1141, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1458, 1458, 1458, 1458, 1458, 1136, 1458,
     1461, 1485, 1135, 1461, 1485, 1461, 1485, 1122, 1483, 1487,
     1461, 1118, 1487, 1117, 1487, 1116, 1114, 1113, 1461, 1461,
     1461, 1461, 1112, 1111, 1110, 1109, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1462, 1461, 1485, 1462, 1108, 1462, 1107, 1106,
     1105, 1494, 1487, 1100, 1494, 1462, 1494, 1462, 1099, 1462,

     1462, 1462, 1462, 1462, 1462, 1462, 1462, 1462, 1467, 1467,
     1467, 1467, 1467, 1467, 1467, 1467, 1467, 1499, 1086, 1082,
     1081, 1502, 1080, 1079, 1078, 1499, 1499, 1499, 1499, 1502,
     1502, 1502, 1502, 1077, 1075, 1462, 1476, 1493, 1074, 1476,
     1493, 1476, 1493, 1520, 1494, 1069, 1520, 1068, 1520, 1535,
     1522, 1524, 1058, 1522, 1524, 1522, 1524, 1535, 1535, 1535,
     1535, 1056, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476,
     1476, 1476, 1476, 1476, 1476, 1476, 1476, 1476, 1478, 1476,
     1493, 1478, 1055, 1478, 1053, 1052, 1520, 1482, 1051, 1049,

     1482, 1048, 1482, 1522, 1524, 1478, 1478, 1478, 1478, 1478,
     1478, 1478, 1478, 1478, 1482, 1482, 1482, 1482, 1482, 1482,
     1482, 1482, 1482, 1536, 1047, 1045, 1044, 1537, 1040, 1034,
     1033, 1536, 1536, 1536, 1536, 1537, 1537, 1537, 1537, 1032,
     1031, 1478, 1480, 1030, 1029, 1480, 1028, 1480, 1026, 1025,
     1482, 1526, 1024, 1023, 1526, 1022, 1526, 1018, 1528, 1530,
     1493, 1528, 1530, 1528, 1530,  992,  989,  988, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480, 1480,
     1480, 1480, 1480, 1480,  987, 1480, 1484,  986,  985, 1484,

      984, 1484, 1497,  982, 1526, 1497,  981, 1497,  977,  976,
      975, 1528, 1530,  965,  963,  962,  961,  960,  959,  958,
      956,  955, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484,
     1484, 1484, 1484, 1484, 1484, 1484, 1484, 1484, 1486, 1484,
      950, 1486,  949, 1486, 1498, 1497,  939, 1498, 1500, 1498,
      937, 1500,  936, 1500, 1497, 1486, 1486, 1486, 1486, 1486,
     1486, 1486, 1486, 1486,  934, 1501,  933, 1497, 1501, 1503,
     1501,  932, 1503, 1504, 1503,  930, 1504,  929, 1504,  928,
      926,  925,  921,  915,  914,  913,  912,  908,  907,  906,

      905, 1486,  904,  903,  902,  901,  900, 1498,  895,  894,
      892, 1500,  880,  856,  822,  821, 1498,  819,  818,  808,
     1500,  807,  805,  804,  803,  801,  800,  799, 1501, 1498,
      797,  796, 1503, 1500,  792,  789, 1504, 1501,  788,  786,
      785, 1503,  784,  782, 1509, 1504,  781, 1509,  780, 1509,
     1501,  778,  777,  773, 1503,  765,  764, 1509, 1504, 1509,
      763, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509, 1509,
      762,  760,  759,  758,  757,  756,  755,  754,  753,  752,
      751,  750,  749,  736,  725,  723,  721,  712,  711,  709,
      708,  700,  694,  690,  654,  653,  647, 1509, 1510,  646,

      645,  644,  643,  641,  610,  606, 1510, 1510, 1510, 1510,
      591,  590,  587,  586, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510, 1510,
     1511,  585,  584, 1511,  582, 1511,  581,  580,  579,  578,
      577,  576,  574, 1511,  573, 1511,  570, 1511, 1511, 1511,
     1511, 1511, 1511, 1511, 1511, 1511,  569,  559,  556,  550,
      546,  543,  542,  541,  535,  533,  532,  524,  521,  511,
      510,  509,  506,  505,  504,  494,  493,  458,  457,  453,
      451,  449,  448, 1511, 1512,  444,  426,  416,  415,  414,

      412,  411, 1512, 1512, 1512, 1512,  399,  397,  396,  395,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1512,
     1512, 1512, 1512, 1512, 1512, 1512, 1513,  394,  393, 1513,
      392, 1513,  390,  389,  388,  387,  385,  384,  383, 1513,
      381, 1513,  380, 1513, 1513, 1513, 1513, 1513, 1513, 1513,
     1513, 1513,  379,  377,  376,  375,  374,  373,  369,  367,
      364,  359,  358,  356,  349,  348,  347,  346,  345,  344,
      330,  329,  327,  326,  323,  322,  320,  319,  317, 1513,
     1514,  314,  312,  298,  297,  289,  288,  287, 1514, 1514,

     1514, 1514,  286,  285,  283,  278, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1514, 1519,  274,  271, 1519,  268, 1519,  267,  264,
      259,  257,  255,  245,  237,  235,  232,  228,  226, 1519,
     1519, 1519, 1519, 1519, 1519, 1519, 1519, 1519,  221, 1523,
      218,  216, 1523,  215, 1523,  214,  213,  211,  209,  203,
      199,  198,  196,  193,  182,  181, 1523, 1523, 1523, 1523,
     1523, 1523, 1523, 1523, 1523, 1519, 1521, 1521, 1521, 1521,
     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,

     1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1521, 1523, 1525, 1525, 1525, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525,
     1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1525, 1527,
      180,  176, 1527,  175, 1527,  174,  161,  153,  146,  145,
      143,  140,  125,  124,  120,  119, 1527, 1527, 1527, 1527,
     1527, 1527, 1527, 1527, 1527,  118,  112,  105,  102,  100,
       96,   95,   93,   92,   89,   88,   85,   81,   78,   75,
       72,   71,   70,   69,   65,   62,   58,   57,   54,   49,
       47,   46, 1527, 1529, 1529, 1529, 1529, 1529, 1529, 1529,

     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1529, 1559,
     1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559, 1559,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560, 1560,
     1560, 1561, 1561, 1561, 1561, 1561, 1561, 1561, 1561, 1561,
     1561, 1561, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562,
     1562, 1562, 1562, 1563, 1563, 1563, 1563, 1563, 1563, 1563,
     1563, 1563, 1563, 1563, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1564, 1564, 1564, 1564, 1565, 1565, 1565, 1565, 1565,
     1565, 1565, 1565, 1565, 1565, 1565, 1566, 1566, 1566, 1566,

     1566, 1566, 1566, 1566, 1566, 1566, 1566, 1567, 1567, 1567,
     1567, 1567, 1567, 1567, 1567, 1567, 1567, 1567, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1568, 1569,
     1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569, 1569,
     1570, 1570, 1570, 1570, 1571, 1571,   41, 1571, 1571, 1571,
     1571, 1571, 1571, 1571, 1571, 1572,   37,   36,   35, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1573, 1573,   18,   17,
     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1574, 1574,    0,
     1574, 1574, 1574, 1574, 1574, 1574, 1574, 1574, 1575,    0,
        0,    0, 1575, 1575, 1575, 1575, 1575, 1575, 1575, 1576,

        0,    0,    0, 1576, 1576, 1576, 1576, 1576, 1576, 1576,
     1577,    0,    0,    0, 1577, 1577, 1577, 1577, 1577, 1577,
     1577, 1578, 1578,    0, 1578, 1578, 1578, 1578, 1578, 1578,
     1578, 1578, 1579, 1579,    0, 1579, 1579, 1579, 1579, 1579,
     1579, 1579, 1579, 1580, 1580,    0, 1580, 1580, 1580, 1580,
     1580, 1580, 1580, 1580, 1581, 1581,    0, 1581, 1581, 1581,
     1581, 1581, 1581, 1581, 1581, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1583, 1583, 1583, 1583,
     1584, 1584,    0, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1585, 1585,    0, 1585, 1585, 1585, 1585, 1585, 1585,

     1585, 1585, 1586, 1586,    0, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1587, 1587,    0, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1588,    0, 1588, 1588, 1589, 1589,
     1590,    0,    0, 1590, 1590, 1591,    0,    0,    0, 1591,
     1591, 1591, 1591, 1591, 1591, 1591, 1592, 1592,    0,    0,
     1592, 1592, 1592, 1592, 1592, 1592, 1592, 1593, 1593,    0,
     1593, 1593, 1593, 1593, 1593, 1593, 1593, 1593, 1594,    0,
        0,    0, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1595,
        0,    0,    0, 1595, 1595, 1595, 1595, 1595, 1595, 1595,
     1596,    0,    0,    0, 1596, 1596, 1596, 1596, 1596, 1596,

     1596, 1597, 1597, 1597, 1597, 1597, 1597, 1597, 1597, 1597,
     1597, 1597, 1598, 1598,    0, 1598, 1598, 1598, 1598, 1598,
     1598, 1598, 1598, 1599, 1599,    0, 1599, 1599, 1599, 1599,
     1599, 1599, 1599, 1599, 1600, 1600,    0, 1600, 1600, 1600,
     1600, 1600, 1600, 1600, 1600, 1601, 1601,    0, 1601, 1601,
     1601, 1601, 1601, 1601, 1601, 1601, 1602, 1602,    0, 1602,
     1602, 1602, 1602, 1602, 1602, 1602, 1602, 1603, 1603, 1603,
     1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1605, 1605,
        0, 1605, 1605, 1605, 1605, 1605, 1605, 1605, 1605, 1606,
     1606,    0, 1606, 1606, 1606, 1606, 1606, 1606, 1606, 1606,

     1607, 1607,    0, 1607, 1607, 1607, 1607, 1607, 1607, 1607,
     1607, 1608, 1608,    0, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1609, 1609,    0, 1609, 1609, 1609, 1609, 1609,
     1609, 1609, 1609, 1610, 1610,    0, 1610, 1610, 1610, 1610,
     1610, 1610, 1610, 1610, 1611, 1611, 1611, 1611, 1611,    0,
     1611, 1611, 1611, 1611, 1611, 1612, 1612,    0, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1614, 1614, 1615, 1615,
     1615, 1615,    0, 1615, 1615, 1615, 1615, 1615, 1615, 1616,
     1616, 1616, 1616, 1616,    0, 1616, 1616, 1616, 1616, 1616,
     1617, 1617,    0, 1617, 1617, 1617, 1617, 1617, 1617, 1617,

     1617, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618, 1618,
     1618, 1618, 1619, 1619,    0, 1619, 1619, 1619, 1619, 1619,
     1619, 1619, 1619, 1620, 1620,    0, 1620, 1620, 1620, 1620,
     1620, 1620, 1620, 1620, 1621, 1621,    0, 1621, 1621, 1621,
     1621, 1621, 1621, 1621, 1621, 1622, 1622,    0, 1622, 1622,
     1622, 1622, 1622, 1622, 1622, 1622, 1623, 1623,    0, 1623,
     1623, 1623, 1623, 1623, 1623, 1623, 1623, 1624, 1624,    0,
     1624, 1624, 1624, 1624, 1624, 1624, 1624, 1624, 1625, 1625,
        0, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1625, 1626,
     1626,    0, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626,

     1627, 1627,    0, 1627, 1627, 1627, 1627, 1627, 1627, 1627,
     1627, 1628, 1628,    0, 1628, 1628, 1628, 1628, 1628, 1628,
     1628, 1628, 1629, 1629,    0, 1629, 1629, 1629, 1629, 1629,
     1629, 1629, 1629, 1630, 1630,    0, 1630, 1630, 1630, 1630,
     1630, 1630, 1630, 1630, 1631, 1631,    0, 1631, 1631, 1631,
     1631, 1631, 1631, 1631, 1631, 1632, 1632,    0, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1633, 1633,    0, 1633,
     1633, 1633, 1633, 1633, 1633, 1633, 1633, 1634, 1634, 1634,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1636, 1636,
     1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637, 1637,

     1637, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638, 1638,
     1638, 1638, 1639, 1639,    0, 1639, 1639, 1639, 1639, 1639,
     1639, 1639, 1639, 1640, 1640,    0, 1640, 1640, 1640, 1640,
     1640, 1640, 1640, 1640, 1641, 1641,    0, 1641, 1641, 1641,
     1641, 1641, 1641, 1641, 1641, 1642, 1642,    0, 1642, 1642,
     1642, 1642, 1642, 1642, 1642, 1642, 1643, 1643,    0, 1643,
     1643, 1643, 1643, 1643, 1643, 1643, 1643, 1644, 1644,    0,
     1644, 1644, 1644, 1644, 1644, 1644, 1644, 1644, 1645, 1645,
        0, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1646,
     1646,    0, 1646, 1646, 1646, 1646, 1646, 1646, 1646, 1646,

     1647, 1647,    0, 1647, 1647, 1647, 1647, 1647, 1647, 1647,
     1647, 1648, 1648,    0, 1648, 1648, 1648, 1648, 1648, 1648,
     1648, 1648, 1649, 1649,    0, 1649, 1649, 1649, 1649, 1649,
     1649, 1649, 1649, 1650, 1650,    0, 1650, 1650, 1650, 1650,
     1650, 1650, 1650, 1650, 1651, 1651,    0, 1651, 1651, 1651,
     1651, 1651, 1651, 1651, 1651, 1652, 1652,    0, 1652, 1652,
     1652, 1652, 1652, 1652, 1652, 1652, 1653, 1653,    0, 1653,
     1653, 1653, 1653, 1653, 1653, 1653, 1653, 1654, 1654,    0,
     1654, 1654, 1654, 1654, 1654, 1654, 1654, 1654, 1655, 1655,
        0, 1655, 1655, 1655, 1655, 1655, 1655, 1655, 1655, 1656,

     1656,    0, 1656, 1656, 1656, 1656, 1656, 1656, 1656, 1656,
     1657, 1657,    0, 1657, 1657, 1657, 1657, 1657, 1657, 1657,
     1657, 1658, 1658,    0, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1659, 1659,    0, 1659, 1659, 1659, 1659, 1659,
     1659, 1659, 1659, 1660, 1660, 1660, 1660, 1660, 1660, 1660,
     1660, 1660, 1660, 1660, 1661, 1661, 1661, 1661, 1661, 1661,
     1661, 1661, 1661, 1661, 1661, 1662, 1662, 1662, 1662, 1662,
     1662, 1662, 1662, 1662, 1662, 1662, 1663, 1663,    0, 1663,
     1663, 1663, 1663, 1663, 1663, 1663, 1663, 1664, 1664,    0,
     1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1665, 1665,

        0, 1665, 1665, 1665, 1665, 1665, 1665, 1665, 1665, 1666,
     1666,    0, 1666, 1666, 1666, 1666, 1666, 1666, 1666, 1666,
     1667, 1667,    0, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1668, 1668,    0, 1668, 1668, 1668, 1668, 1668, 1668,
     1668, 1668, 1669, 1669,    0, 1669, 1669, 1669, 1669, 1669,
     1669, 1669, 1669, 1670, 1670,    0, 1670, 1670, 1670, 1670,
     1670, 1670, 1670, 1670, 1671, 1671,    0, 1671, 1671, 1671,
     1671, 1671, 1671, 1671, 1671, 1672,    0, 1672, 1672, 1672,
     1672, 1672, 1672, 1672, 1672, 1672, 1673, 1673,    0, 1673,
     1673, 1673, 1673, 1673, 1673, 1673, 1673, 1674, 1674, 1674,

     1674, 1674, 1674, 1674, 1674, 1674, 1674, 1674, 1675, 1675,
        0, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1675, 1676,
     1676,    0, 1676, 1676, 1676, 1676, 1676, 1676, 1676, 1676,
     1677, 1677,    0, 1677, 1677, 1677, 1677, 1677, 1677, 1677,
     1677, 1678, 1678,    0, 1678, 1678, 1678, 1678, 1678, 1678,
     1678, 1678, 1679, 1679,    0, 1679, 1679, 1679, 1679, 1679,
     1679, 1679, 1679, 1680, 1680,    0, 1680, 1680, 1680, 1680,
     1680, 1680, 1680, 1680, 1681, 1681,    0, 1681, 1681, 1681,
     1681, 1681, 1681, 1681, 1681, 1682, 1682,    0, 1682, 1682,
     1682, 1682, 1682, 1682, 1682, 1682, 1683, 1683,    0, 1683,

     1683, 1683, 1683, 1683, 1683, 1683, 1683, 1684, 1684,    0,
     1684, 1684, 1684, 1684, 1684, 1684, 1684, 1684, 1685, 1685,
        0, 1685, 1685, 1685, 1685, 1685, 1685, 1685, 1685, 1686,
     1686,    0, 1686, 1686, 1686, 1686, 1686, 1686, 1686, 1686,
     1687, 1687,    0, 1687, 1687, 1687, 1687, 1687, 1687, 1687,
     1687, 1688, 1688,    0, 1688, 1688, 1688, 1688, 1688, 1688,
     1688, 1688, 1689, 1689,    0, 1689, 1689, 1689, 1689, 1689,
     1689, 1689, 1689, 1690, 1690,    0, 1690, 1690, 1690, 1690,
     1690, 1690, 1690, 1690, 1691, 1691,    0, 1691, 1691, 1691,
     1691, 1691, 1691, 1691, 1691, 1692, 1692,    0, 1692, 1692,

     1692, 1692, 1692, 1692, 1692, 1692, 1693, 1693,    0, 1693,
     1693, 1693, 1693, 1693, 1693, 1693, 1693, 1694, 1694,    0,
     1694, 1694, 1694, 1694, 1694, 1694, 1694, 1694, 1695, 1695,
        0, 1695, 1695, 1695, 1695, 1695, 1695, 1695, 1695, 1696,
     1696,    0, 1696, 1696, 1696, 1696, 1696, 1696, 1696, 1696,
     1697, 1697,    0, 1697, 1697, 1697, 1697, 1697, 1697, 1697,
     1697, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698, 1698,
     1698, 1698, 1699, 1699, 1699, 1699, 1699, 1699, 1699, 1699,
     1699, 1699, 1699, 1700, 1700, 1700, 1700, 1700, 1700, 1700,
     1700, 1700, 1700, 1700, 1701, 1701,    0, 1701, 1701, 1701,

     1701, 1701, 1701, 1701, 1701, 1702, 1702,    0, 1702, 1702,
     1702, 1702, 1702, 1702, 1702, 1702, 1703, 1703,    0, 1703,
     1703, 1703, 1703, 1703, 1703, 1703, 1703, 1704, 1704,    0,
     1704, 1704, 1704, 1704, 1704, 1704, 1704, 1704, 1705, 1705,
        0, 1705, 1705, 1705, 1705, 1705, 1705, 1705, 1705, 1706,
     1706,    0, 1706, 1706, 1706, 1706, 1706, 1706, 1706, 1706,
     1707, 1707,    0, 1707, 1707, 1707, 1707, 1707, 1707, 1707,
     1707, 1708,    0, 1708, 1708, 1708, 1708, 1708, 1708, 1708,
     1708, 1708, 1709, 1709,    0, 1709, 1709, 1709, 1709, 1709,
     1709, 1709, 1709, 1710, 1710,    0, 1710, 1710, 1710, 1710,

     1710, 1710, 1710, 1710, 1711, 1711,    0, 1711, 1711, 1711,
     1711, 1711, 1711, 1711, 1711, 1712,    0, 1712, 1712, 1713,
     1713,    0, 1713, 1713, 1713, 1713, 1713, 1713, 1713, 1713,
     1714, 1714,    0, 1714, 1714, 1714, 1714, 1714, 1714, 1714,
     1714, 1715, 1715,    0, 1715, 1715, 1715, 1715, 1715, 1715,
     1715, 1715, 1716, 1716,    0, 1716, 1716, 1716, 1716, 1716,
     1716, 1716, 1716, 1717, 1717,    0, 1717, 1717, 1717, 1717,
     1717, 1717, 1717, 1717, 1718, 1718,    0, 1718, 1718, 1718,
     1718, 1718, 1718, 1718, 1718, 1719, 1719,    0, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719, 1720, 1720,    0, 1720,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1721, 1721, 1721,
     1721, 1721, 1721, 1721, 1721, 1721, 1721, 1721, 1722, 1722,
        0, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1722, 1723,
     1723,    0, 1723, 1723, 1723, 1723, 1723, 1723, 1723, 1723,
     1724, 1724,    0, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1726, 1726,    0, 1726, 1726, 1726, 1726, 1726, 1726,
     1726, 1726, 1727, 1727,    0, 1727, 1727, 1727, 1727, 1727,
     1727, 1727, 1727, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1730, 1730, 1730, 1730, 1730,

     1730, 1730, 1730, 1730, 1730, 1730, 1731, 1731,    0, 1731,
     1731, 1731, 1731, 1731, 1731, 1731, 1731, 1732,    0, 1732,
        0, 1732, 1732, 1733, 1733,    0, 1733, 1733, 1733, 1733,
     1733, 1733, 1733, 1733, 1734,    0, 1734, 1734, 1735,    0,
     1735, 1735, 1738, 1738,    0, 1738, 1738, 1738, 1738, 1738,
     1738, 1738, 1738, 1739, 1739,    0, 1739, 1739, 1739, 1739,
     1739, 1739, 1739, 1739, 1740, 1740,    0, 1740, 1740, 1740,
     1740, 1740, 1740, 1740, 1740, 1741,    0, 1741, 1741, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,

     1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558, 1558,
     1558, 1558, 1558, 1558
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk)
 *
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "error.h"
#include "xalloc.h"

#include "gettext.h"
#define _(String) gettext (String)

#include "encodings.h"
#include "pipeline.h"
#include "sandbox.h"
#include "security.h"
#include "util.h"

#include "decompress.h"
#include "lexgrog.h"
#include "manconv.h"
#include "manconv_client.h"

#define YY_READ_BUF_SIZE	1024
#define MAX_NAME		8192

/* defines the ordered list of filters detected by lexgrog */
enum {
	TBL_FILTER = 0,	/* tbl */
	EQN_FILTER,	/* eqn */
	PIC_FILTER,	/* pic */
	GRAP_FILTER,	/* grap */
	REF_FILTER,	/* refer */
	VGRIND_FILTER,	/* vgrind */
	MAX_FILTERS	/* delimiter */
};

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

extern man_sandbox *sandbox;

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static void add_str_to_whatis (const char *string, size_t length);
static void add_char_to_whatis (unsigned char c);
static void add_separator_to_whatis (void);
static void add_wordn_to_whatis (const char *string, size_t length);
static void add_word_to_whatis (const char *string);
static void add_glyph_to_whatis (const char *string, size_t length);
static void add_perldoc_to_whatis (const char *string, size_t length);
static void mdoc_text (const char *string);
static void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static int fill_mode;
static int waiting_for_quote;

static decompress *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = decompress_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 2921 "lexgrog.c"

#line 308 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* ИМЕ also works for mk */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 2932 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 359 "lexgrog.l"


 /* begin NAME section processing */
#line 3168 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1559 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1558 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 362 "lexgrog.l"
BEGIN (MAN_PRENAME);
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 363 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 3:
#line 368 "lexgrog.l"
case 4:
#line 369 "lexgrog.l"
case 5:
#line 370 "lexgrog.l"
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 370 "lexgrog.l"

	YY_BREAK


case 7:
#line 375 "lexgrog.l"
case 8:
#line 376 "lexgrog.l"
case 9:
/* rule 9 can match eol */
#line 377 "lexgrog.l"
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 377 "lexgrog.l"

	YY_BREAK


case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 381 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 382 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 383 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 384 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 15:
/* rule 15 can match eol */
#line 386 "lexgrog.l"
case 16:
/* rule 16 can match eol */
YY_RULE_SETUP
#line 386 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 387 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 389 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 393 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 396 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
#line 402 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 402 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 21:
/* rule 21 can match eol */
#line 411 "lexgrog.l"
case 22:
/* rule 22 can match eol */
#line 412 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 413 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 414 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 415 "lexgrog.l"
case 26:
/* rule 26 can match eol */
YY_RULE_SETUP
#line 415 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 423 "lexgrog.l"

	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 425 "lexgrog.l"
yyless (1);
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 427 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 30:
/* rule 30 can match eol */
#line 434 "lexgrog.l"
case 31:
/* rule 31 can match eol */
#line 435 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 436 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 437 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 438 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 439 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 440 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 440 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 37:
/* rule 37 can match eol */
#line 448 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 449 "lexgrog.l"
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 449 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 459 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = 1;
	}
	YY_BREAK
case 41:
/* rule 41 can match eol */
#line 465 "lexgrog.l"
case 42:
/* rule 42 can match eol */
#line 466 "lexgrog.l"
case 43:
/* rule 43 can match eol */
#line 467 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 468 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 469 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 470 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 471 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 472 "lexgrog.l"
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 472 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 50:
/* rule 50 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 479 "lexgrog.l"
newline_found ();
	YY_BREAK
case 51:
/* rule 51 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 480 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 485 "lexgrog.l"
fill_mode = 0;
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 486 "lexgrog.l"
fill_mode = 1;
	YY_BREAK

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 489 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 55:
/* rule 55 can match eol */
#line 494 "lexgrog.l"
case 56:
/* rule 56 can match eol */
#line 495 "lexgrog.l"
case 57:
/* rule 57 can match eol */
#line 496 "lexgrog.l"
case 58:
/* rule 58 can match eol */
#line 497 "lexgrog.l"
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 497 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 502 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 506 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 507 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 508 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 509 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 510 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 511 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 512 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 514 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 516 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 517 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 519 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 522 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 524 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 525 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 527 "lexgrog.l"
/* comment */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 529 "lexgrog.l"
/* font changes */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 530 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 532 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 533 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 535 "lexgrog.l"
/* size changes */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 536 "lexgrog.l"
/* width of string */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 538 "lexgrog.l"
/* catch all */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 540 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 547 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 548 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 549 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 550 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 551 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 552 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 553 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 555 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 93:
YY_RULE_SETUP
#line 562 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 563 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 564 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 565 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 566 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 567 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 568 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 569 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 570 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 571 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 572 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 573 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 574 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 575 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 107:
YY_RULE_SETUP
#line 582 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 587 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 109:
YY_RULE_SETUP
#line 594 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 595 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 596 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 597 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 602 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 114:
YY_RULE_SETUP
#line 609 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 613 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 617 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 621 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 625 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 119:
YY_RULE_SETUP
#line 631 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 120:
YY_RULE_SETUP
#line 638 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 643 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 122:
YY_RULE_SETUP
#line 650 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 655 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 124:
YY_RULE_SETUP
#line 662 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 667 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 674 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 127:
/* rule 127 can match eol */
#line 681 "lexgrog.l"
case 128:
/* rule 128 can match eol */
#line 682 "lexgrog.l"
case 129:
/* rule 129 can match eol */
#line 683 "lexgrog.l"
case 130:
/* rule 130 can match eol */
#line 684 "lexgrog.l"
case 131:
/* rule 131 can match eol */
#line 685 "lexgrog.l"
case 132:
/* rule 132 can match eol */
#line 686 "lexgrog.l"
case 133:
/* rule 133 can match eol */
#line 687 "lexgrog.l"
case 134:
/* rule 134 can match eol */
YY_RULE_SETUP
#line 687 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 694 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 136:
YY_RULE_SETUP
#line 700 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 137:
/* rule 137 can match eol */
#line 704 "lexgrog.l"
case 138:
/* rule 138 can match eol */
YY_RULE_SETUP
#line 704 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 706 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 711 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 714 "lexgrog.l"
return 1;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 716 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4112 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1559 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1559 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1558);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 716 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
}

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = 0;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = 0;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret = 0;
	decompress *d;
	char *page_encoding = NULL;
	bool run_col = p_lg->type == CATPAGE && *PROG_COL != '\0';

	if (strcmp (file, "-") == 0) {
		d = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		int decompress_flags;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		decompress_flags = 0;
		/* If we're looking at a cat page, then we need to run col
		 * over it, which doesn't work conveniently with an
		 * in-process decompressor.
		 */
		if (!run_col)
			decompress_flags |= DECOMPRESS_ALLOW_INPROCESS;
		d = decompress_open (file, decompress_flags);
		if (!d) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding) {
		if (decompress_is_pipeline (d))
			add_manconv (decompress_get_pipeline (d),
				     page_encoding, "UTF-8");
		else if (manconv_inprocess (d, page_encoding, "UTF-8") != 0)
			/* manconv should already have written to stderr, so
			 * just return zero (i.e. no result).
			 */
			goto out;
	}
	if (run_col) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args
			(PROG_COL, "-b", "-p", "-x", (void *) 0);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (decompress_get_pipeline (d), col_cmd);
	}
	decompress_start (d);

	ret = find_name_decompressed (d, filename, p_lg);

out:
	free (page_encoding);
	decompress_free (d);
	return ret;
}

int find_name_decompressed (decompress *d, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = d;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = 1;
	waiting_for_quote = 0;

	if (p_lg->type == CATPAGE)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	decompress_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

